;***	Translateable text for command.com resident data.


;*	Input characters for critical error "Abort, Retry, Fail, Ignore?"
;	and Yes/No.

Abort_Char	db	"A"
Retry_Char	db	"R"
Ignore_Char	db	"I"
Fail_Char	db	"F"
Yes_Char	db	"S"
No_Char 	db	"N"


;*	MESSAGES
;
;	See resmsg.equ for macro definition.


;*	Local messages.

	msg	Req_Abort, <"Abortar">
	msg	Req_Retry, <", Repetir">
	msg	Req_Ignore,<", Ignorar">
	msg	Req_Fail,  <", Falhar">
	msg	Req_End,   <"?">
	msg	MRead,	   <"a ler",0>
	msg	MWrite,	   <"a escrever",0>
	msg	BlkDevErr, <" %1 unidade %2",CR,LF>
	msg	CharDevErr,<" %1 dispositivo %2",CR,LF>
	msg	NeedVolMsg,<"Introduza volume %1 n. srie %2-%3",CR,LF>
	msg	BadFatMsg, <"FAT invlida, unidade %1",CR,LF>
	msg	ComBad,	   <"COMMAND.COM invlido",CR,LF>
	msg	PutBackMsg,<"Introduza disco com %1 na unidade %2",CR,LF>
	msg	Prompt,	   <"Prima qualquer tecla para continuar . . .",CR,LF>
	msg	EndBatMes, <CR,LF,"Terminar tarefa batch (S/N)?">
	msg	ExecEMes,  <"Impossvel executar %1",CR,LF>
	msg	ExeBad,	   <"Erro no ficheiro EXE",CR,LF>
	msg	TooBig,	   <"Programa demasiado grande para a memria",CR,LF>
	msg	NoHandMes, <CR,LF,"Sem identificadores de ficheiro livres">
	msg	RBadNam,   <"Comando ou nome de ficheiro no vlido",CR,LF>
	msg	AccDen,	   <"Acesso negado ">
	msg	BMemMes,   <CR,LF,"Erro de atribuio de memria">
	msg	HaltMes,   <CR,LF,"Impossvel carregar o COMMAND, sistema parado",CR,LF>
	msg	FRetMes,   <CR,LF,"Impossvel comear o COMMAND, a sair",CR,LF>
	msg	Patricide, <CR,LF,"Processo de topo abortado, impossvel continuar",CR,LF> 
	msg	Newlin,	   <CR,LF>

;*	Ptrs to message lists.
;	Segment portion is 1, signalling message services to call retriever.

MsgPtrLists	label	dword
	dw	DATARES:ExtMsgPtrs,1	; extended error messages
	dw	DATARES:ParsMsgPtrs,1	; parse error messages
	dw	DATARES:ExtMsgPtrs,1	; critical error messages -
					;  use extended error list
	dw	0,0			; file system error messages - none
	dw	DATARES:MsgRetrv_Trap		; address of message retriever
MySeg3	dw	?			;  (segment filled in during init)



;*	Critical error messages.

	msg	ExtErr19,<"Erro de proteco contra escrita ">
	msg	ExtErr20,<"Unidade invlida">
	msg	ExtErr21,<"No preparado">
	msg	ExtErr22,<"Pedido de dispositivo invlido">
	msg	ExtErr23,<"Erro de dados">
	msg	ExtErr24,<"Parmetros de pedido de dispositivo invlidos">
	msg	ExtErr25,<"Erro de procura">
	msg	ExtErr26,<"Tipo de media invlido">
	msg	ExtErr27,<"Sector no encontrado">
	msg	ExtErr28,<"Erro de impressora sem papel">
	msg	ExtErr29,<"Erro de falha na escrita">
	msg	ExtErr30,<"Erro de falha na leitura">
	msg	ExtErr31,<"Falha geral">
	msg	ExtErr32,<"Violao de partilha">
	msg	ExtErr33,<"Violao de bloqueio">
	msg	ExtErr34,<"Troca de disco invlida">
	msg	ExtErr35,<"FCB indisponvel">
	msg	ExtErr36,<"Sem recursos de sistema">
	msg	ExtErr37,<"Discordncia de pg. de cdigos">
	msg	ExtErr38,<"Sem dados de entrada">
	msg	ExtErr39,<"Espao em disco insuficiente">

;	List of ptrs to critical error messages.
;	Code assumes extended error number order, beginning
;	with extended error number 19.

CritMsgPtrs	label	word
	dw	DATARES:ExtErr19,DATARES:ExtErr20,DATARES:ExtErr21,DATARES:ExtErr22,DATARES:ExtErr23,DATARES:ExtErr24
	dw	DATARES:ExtErr25,DATARES:ExtErr26,DATARES:ExtErr27,DATARES:ExtErr28,DATARES:ExtErr29,DATARES:ExtErr30
	dw	DATARES:ExtErr31,DATARES:ExtErr32,DATARES:ExtErr33,DATARES:ExtErr34,DATARES:ExtErr35,DATARES:ExtErr36
	dw	DATARES:ExtErr37,DATARES:ExtErr38,DATARES:ExtErr39

DataResEnd	label	byte	; end of resident portion if /msg not used



;*	Parse error messages.

	msg	ParsErr01,<"Demasiados parmetros">
	msg	ParsErr02,<"Falta(m) parmetro(s) necessrio(s)">
	msg	ParsErr03,<"Parmetro invlido">
	msg	ParsErr04,<"Palavra-chave invlida">
	msg	ParsErr05,<" ">
	msg	ParsErr06,<"Valor do parmetro fora do intervalo permitido">
	msg	ParsErr07,<"Valor do parmetro no permitido">
	msg	ParsErr08,<"Valor do parmetro no permitido">
	msg	ParsErr09,<"Formato incorrecto do parmetro">
	msg	ParsErr10,<"Parmetro invlido">
	msg	ParsErr11,<"Combinao de parmtros invlida">

;	List of ptrs to parse error messages.
;	In order, beginning with parse error number 1.

ParsMsgPtrs	label	word
	dw	DATARES:ParsErr01,DATARES:ParsErr02,DATARES:ParsErr03
	dw	DATARES:ParsErr04,DATARES:ParsErr05,DATARES:ParsErr06
	dw	DATARES:ParsErr07,DATARES:ParsErr08,DATARES:ParsErr09
	dw	DATARES:ParsErr10,DATARES:ParsErr11

NUMPARSMSGS	equ	($ - ParsMsgPtrs) / 2	;M033


;*	Extended error messages.

	msg	ExtErr01,<"Funo invlida">
	msg	ExtErr02,<"Ficheiro no enontrado">
	msg	ExtErr03,<"Caminho no encontrado">
	msg	ExtErr04,<"Demasiados ficheiros abertos">
	msg	ExtErr05,<"Acesso negado ">
	msg	ExtErr06,<"Identificador invlido">
	msg	ExtErr07,<"Blocos de controlo de memria destrudos">
	msg	ExtErr08,<"Memria insuficiente">
	msg	ExtErr09,<"Endereo de blocos de memria invlido">
	msg	ExtErr10,<"Ambiente invlido">
	msg	ExtErr11,<"Formato invlido">
	msg	ExtErr12,<"Parmetro de funo invlido">
	msg	ExtErr13,<"Dados invlidos">

	msg	ExtErr15,<"Especificao de unidade invlida">
	msg	ExtErr16,<"Tentativa de remoo do directrio actual">
	msg	ExtErr17,<"No  o mesmo dispositivo">
	msg	ExtErr18,<"No h mais ficheiros">

	msg	ExtErr80,<"Ficheiro existe">

	msg	ExtErr82,<"Impossvel criar entrada de directrio">
	msg	ExtErr83,<"Falha no INT 24">
	msg	ExtErr84,<"Demasiados redireccionamentos">
	msg	ExtErr85,<"Redireccionamento duplo">
	msg	ExtErr86,<"Palavra-passe invlida">
	msg	ExtErr87,<"Parmetro invlido">
	msg	ExtErr88,<"Falha de dados de rede">
	msg	ExtErr89,<"Funo no suportada pela rede">
	msg	ExtErr90,<"Componente de sistema necessrio no instalado">

;	List of ptrs to extended error messages.
;	In order, beginning with extended error number 1.
;	Critical error messages are included here, as well as in the
;	critical error message list.  
;	Error numbers without messages are included as null ptrs.

ExtMsgPtrs	label	word
	dw	DATARES:ExtErr01,DATARES:ExtErr02,DATARES:ExtErr03
	dw	DATARES:ExtErr04,DATARES:ExtErr05,DATARES:ExtErr06
	dw	DATARES:ExtErr07,DATARES:ExtErr08,DATARES:ExtErr09
	dw	DATARES:ExtErr10,DATARES:ExtErr11,DATARES:ExtErr12
	dw	DATARES:ExtErr13,0,                DATARES:ExtErr15
	dw	DATARES:ExtErr16,DATARES:ExtErr17,DATARES:ExtErr18
	dw	DATARES:ExtErr19,DATARES:ExtErr20,DATARES:ExtErr21
	dw	DATARES:ExtErr22,DATARES:ExtErr23,DATARES:ExtErr24
	dw	DATARES:ExtErr25,DATARES:ExtErr26,DATARES:ExtErr27
	dw	DATARES:ExtErr28,DATARES:ExtErr29,DATARES:ExtErr30
	dw	DATARES:ExtErr31,DATARES:ExtErr32,DATARES:ExtErr33
	dw	DATARES:ExtErr34,DATARES:ExtErr35,DATARES:ExtErr36
	dw	DATARES:ExtErr37,DATARES:ExtErr38,DATARES:ExtErr39
	dw	80-40 dup (0) ; null ptrs for errors 40-79
	dw	DATARES:ExtErr80,0,                DATARES:ExtErr82
	dw	DATARES:ExtErr83,DATARES:ExtErr84,DATARES:ExtErr85
	dw	DATARES:ExtErr86,DATARES:ExtErr87,DATARES:ExtErr88
	dw	DATARES:ExtErr89,DATARES:ExtErr90
ExtMsgPtrsEnd	label	word

NUMEXTMSGS	equ	($ - ExtMsgPtrs) / 2	;M033

ExtMsgEnd	label	byte	; end of extended error messages
				; = end of resident if /msg is used
