/*++

Copyright (c) 1994  Microsoft Corporation

Module Name:

    oldstub.c

Abstract:

    This file contains functions generated by midl v1.0.  These
    function were designed to only be called by the stubs,
    these paticular functions are called by user code.  This
    file is needed in order to compile lsa with midl v2.0 which
    doesn't generated these paticular functions anymore.

Author:

    Mario Goertzel      (MarioGo)    Jan 10, 1994

Environment:

    User Mode - Win32

Revision History:


--*/

#include <lsarpc.h>

/* routine that frees graph for struct _STRING */
void _fgs__STRING (STRING  * _source)
  {
  if (_source->Buffer !=0)
    {
    MIDL_user_free((void  *)(_source->Buffer));
    }
  }

  /* routine that frees graph for struct _LSAPR_SID_INFORMATION */
void _fgs__LSAPR_SID_INFORMATION (LSAPR_SID_INFORMATION  * _source)
  {
  if (_source->Sid !=0)
    {
    MIDL_user_free((void  *)(_source->Sid));
    }
  }

  /* routine that frees graph for struct _LSAPR_SID_ENUM_BUFFER */
void _fgs__LSAPR_SID_ENUM_BUFFER (LSAPR_SID_ENUM_BUFFER  * _source)
  {
  if (_source->SidInfo !=0)
    {
      {
      unsigned long _sym5;
      for (_sym5 = 0; _sym5 < (unsigned long )(0 + _source->Entries); _sym5++)
        {
        _fgs__LSAPR_SID_INFORMATION ((LSAPR_SID_INFORMATION *)&_source->SidInfo[_sym5]);
        }
      }
    MIDL_user_free((void  *)(_source->SidInfo));
    }
  }

  /* routine that frees graph for struct _LSAPR_ACCOUNT_INFORMATION */
void _fgs__LSAPR_ACCOUNT_INFORMATION (LSAPR_ACCOUNT_INFORMATION  * _source)
  {
  if (_source->Sid !=0)
    {
    MIDL_user_free((void  *)(_source->Sid));
    }
  }

  /* routine that frees graph for struct _LSAPR_ACCOUNT_ENUM_BUFFER */
void _fgs__LSAPR_ACCOUNT_ENUM_BUFFER (LSAPR_ACCOUNT_ENUM_BUFFER  * _source)
  {
  if (_source->Information !=0)
    {
      {
      unsigned long _sym11;
      for (_sym11 = 0; _sym11 < (unsigned long )(0 + _source->EntriesRead); _sym11++)
        {
        _fgs__LSAPR_ACCOUNT_INFORMATION ((LSAPR_ACCOUNT_INFORMATION *)&_source->Information[_sym11]);
        }
      }
    MIDL_user_free((void  *)(_source->Information));
    }
  }

  /* routine that frees graph for struct _LSAPR_UNICODE_STRING */
void _fgs__LSAPR_UNICODE_STRING (LSAPR_UNICODE_STRING  * _source)
  {
  if (_source->Buffer !=0)
    {
    MIDL_user_free((void  *)(_source->Buffer));
    }
  }

  /* routine that frees graph for struct _LSAPR_SECURITY_DESCRIPTOR */
void _fgs__LSAPR_SECURITY_DESCRIPTOR (LSAPR_SECURITY_DESCRIPTOR  * _source)
  {
  if (_source->Owner !=0)
    {
    MIDL_user_free((void  *)(_source->Owner));
    }
  if (_source->Group !=0)
    {
    MIDL_user_free((void  *)(_source->Group));
    }
  if (_source->Sacl !=0)
    {
    MIDL_user_free((void  *)(_source->Sacl));
    }
  if (_source->Dacl !=0)
    {
    MIDL_user_free((void  *)(_source->Dacl));
    }
  }

  /* routine that frees graph for struct _LSAPR_SR_SECURITY_DESCRIPTOR */
void _fgs__LSAPR_SR_SECURITY_DESCRIPTOR (LSAPR_SR_SECURITY_DESCRIPTOR  * _source)
  {
  if (_source->SecurityDescriptor !=0)
    {
    MIDL_user_free((void  *)(_source->SecurityDescriptor));
    }
  }

  /* routine that frees graph for struct _LSAPR_POLICY_PRIVILEGE_DEF */
void _fgs__LSAPR_POLICY_PRIVILEGE_DEF (LSAPR_POLICY_PRIVILEGE_DEF  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->Name);
  }

  /* routine that frees graph for struct _LSAPR_PRIVILEGE_ENUM_BUFFER */
void _fgs__LSAPR_PRIVILEGE_ENUM_BUFFER (LSAPR_PRIVILEGE_ENUM_BUFFER  * _source)
  {
  if (_source->Privileges !=0)
    {
      {
      unsigned long _sym25;
      for (_sym25 = 0; _sym25 < (unsigned long )(0 + _source->Entries); _sym25++)
        {
        _fgs__LSAPR_POLICY_PRIVILEGE_DEF ((LSAPR_POLICY_PRIVILEGE_DEF *)&_source->Privileges[_sym25]);
        }
      }
    MIDL_user_free((void  *)(_source->Privileges));
    }
  }

  /* routine that frees graph for struct _LSAPR_OBJECT_ATTRIBUTES */
void _fgs__LSAPR_OBJECT_ATTRIBUTES (LSAPR_OBJECT_ATTRIBUTES  * _source)
  {
  if (_source->RootDirectory !=0)
    {
    MIDL_user_free((void  *)(_source->RootDirectory));
    }
  if (_source->ObjectName !=0)
    {
    _fgs__STRING ((STRING *)_source->ObjectName);
    MIDL_user_free((void  *)(_source->ObjectName));
    }
  if (_source->SecurityDescriptor !=0)
    {
    _fgs__LSAPR_SECURITY_DESCRIPTOR ((LSAPR_SECURITY_DESCRIPTOR *)_source->SecurityDescriptor);
    MIDL_user_free((void  *)(_source->SecurityDescriptor));
    }
  if (_source->SecurityQualityOfService !=0)
    {
    MIDL_user_free((void  *)(_source->SecurityQualityOfService));
    }
  }

  /* routine that frees graph for struct _LSAPR_CR_CIPHER_VALUE */
void _fgs__LSAPR_CR_CIPHER_VALUE (LSAPR_CR_CIPHER_VALUE  * _source)
  {
  if (_source->Buffer !=0)
    {
    MIDL_user_free((void  *)(_source->Buffer));
    }
  }

  /* routine that frees graph for struct _LSAPR_TRUST_INFORMATION */
void _fgs__LSAPR_TRUST_INFORMATION (LSAPR_TRUST_INFORMATION  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->Name);
  if (_source->Sid !=0)
    {
    MIDL_user_free((void  *)(_source->Sid));
    }
  }

  /* routine that frees graph for struct _LSAPR_TRUSTED_ENUM_BUFFER */
void _fgs__LSAPR_TRUSTED_ENUM_BUFFER (LSAPR_TRUSTED_ENUM_BUFFER  * _source)
  {
  if (_source->Information !=0)
    {
      {
      unsigned long _sym31;
      for (_sym31 = 0; _sym31 < (unsigned long )(0 + _source->EntriesRead); _sym31++)
        {
        _fgs__LSAPR_TRUST_INFORMATION ((LSAPR_TRUST_INFORMATION *)&_source->Information[_sym31]);
        }
      }
    MIDL_user_free((void  *)(_source->Information));
    }
  }

  /* routine that frees graph for struct _LSAPR_REFERENCED_DOMAIN_LIST */
void _fgs__LSAPR_REFERENCED_DOMAIN_LIST (LSAPR_REFERENCED_DOMAIN_LIST  * _source)
  {
  if (_source->Domains !=0)
    {
      {
      unsigned long _sym37;
      for (_sym37 = 0; _sym37 < (unsigned long )(0 + _source->Entries); _sym37++)
        {
        _fgs__LSAPR_TRUST_INFORMATION ((LSAPR_TRUST_INFORMATION *)&_source->Domains[_sym37]);
        }
      }
    MIDL_user_free((void  *)(_source->Domains));
    }
  }

  /* routine that frees graph for struct _LSAPR_TRANSLATED_SIDS */
void _fgs__LSAPR_TRANSLATED_SIDS (LSAPR_TRANSLATED_SIDS  * _source)
  {
  if (_source->Sids !=0)
    {
    MIDL_user_free((void  *)(_source->Sids));
    }
  }

  /* routine that frees graph for struct _LSAPR_TRANSLATED_NAME */
void _fgs__LSAPR_TRANSLATED_NAME (LSAPR_TRANSLATED_NAME  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->Name);
  }

  /* routine that frees graph for struct _LSAPR_TRANSLATED_NAMES */
void _fgs__LSAPR_TRANSLATED_NAMES (LSAPR_TRANSLATED_NAMES  * _source)
  {
  if (_source->Names !=0)
    {
      {
      unsigned long _sym58;
      for (_sym58 = 0; _sym58 < (unsigned long )(0 + _source->Entries); _sym58++)
        {
        _fgs__LSAPR_TRANSLATED_NAME ((LSAPR_TRANSLATED_NAME *)&_source->Names[_sym58]);
        }
      }
    MIDL_user_free((void  *)(_source->Names));
    }
  }

  /* routine that frees graph for struct _LSAPR_POLICY_ACCOUNT_DOM_INFO */
void _fgs__LSAPR_POLICY_ACCOUNT_DOM_INFO (LSAPR_POLICY_ACCOUNT_DOM_INFO  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->DomainName);
  if (_source->DomainSid !=0)
    {
    MIDL_user_free((void  *)(_source->DomainSid));
    }
  }

  /* routine that frees graph for struct _LSAPR_POLICY_PRIMARY_DOM_INFO */
void _fgs__LSAPR_POLICY_PRIMARY_DOM_INFO (LSAPR_POLICY_PRIMARY_DOM_INFO  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->Name);
  if (_source->Sid !=0)
    {
    MIDL_user_free((void  *)(_source->Sid));
    }
  }

  /* routine that frees graph for struct _LSAPR_POLICY_PD_ACCOUNT_INFO */
void _fgs__LSAPR_POLICY_PD_ACCOUNT_INFO (LSAPR_POLICY_PD_ACCOUNT_INFO  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->Name);
  }

  /* routine that frees graph for struct _LSAPR_POLICY_REPLICA_SRCE_INFO */
void _fgs__LSAPR_POLICY_REPLICA_SRCE_INFO (LSAPR_POLICY_REPLICA_SRCE_INFO  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->ReplicaSource);
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->ReplicaAccountName);
  }

  /* routine that frees graph for struct _LSAPR_POLICY_AUDIT_EVENTS_INFO */
void _fgs__LSAPR_POLICY_AUDIT_EVENTS_INFO (LSAPR_POLICY_AUDIT_EVENTS_INFO  * _source)
  {
  if (_source->EventAuditingOptions !=0)
    {
    MIDL_user_free((void  *)(_source->EventAuditingOptions));
    }
  }

  /* routine that frees graph for union _LSAPR_POLICY_INFORMATION */
void _fgu__LSAPR_POLICY_INFORMATION (LSAPR_POLICY_INFORMATION  * _source, POLICY_INFORMATION_CLASS _branch)
  {
  switch (_branch)
    {
    case PolicyAuditLogInformation :
      {
      break;
      }
    case PolicyAuditEventsInformation :
      {
      _fgs__LSAPR_POLICY_AUDIT_EVENTS_INFO ((LSAPR_POLICY_AUDIT_EVENTS_INFO *)&_source->PolicyAuditEventsInfo);
      break;
      }
    case PolicyPrimaryDomainInformation :
      {
      _fgs__LSAPR_POLICY_PRIMARY_DOM_INFO ((LSAPR_POLICY_PRIMARY_DOM_INFO *)&_source->PolicyPrimaryDomainInfo);
      break;
      }
    case PolicyAccountDomainInformation :
      {
      _fgs__LSAPR_POLICY_ACCOUNT_DOM_INFO ((LSAPR_POLICY_ACCOUNT_DOM_INFO *)&_source->PolicyAccountDomainInfo);
      break;
      }
    case PolicyPdAccountInformation :
      {
      _fgs__LSAPR_POLICY_PD_ACCOUNT_INFO ((LSAPR_POLICY_PD_ACCOUNT_INFO *)&_source->PolicyPdAccountInfo);
      break;
      }
    case PolicyLsaServerRoleInformation :
      {
      break;
      }
    case PolicyReplicaSourceInformation :
      {
      _fgs__LSAPR_POLICY_REPLICA_SRCE_INFO ((LSAPR_POLICY_REPLICA_SRCE_INFO *)&_source->PolicyReplicaSourceInfo);
      break;
      }
    case PolicyDefaultQuotaInformation :
      {
      break;
      }
    case PolicyModificationInformation :
      {
      break;
      }
    case PolicyAuditFullSetInformation :
      {
      break;
      }
    case PolicyAuditFullQueryInformation :
      {
      break;
      }
    }
  }

  /* routine that frees graph for struct _LSAPR_TRUSTED_DOMAIN_NAME_INFO */
void _fgs__LSAPR_TRUSTED_DOMAIN_NAME_INFO (LSAPR_TRUSTED_DOMAIN_NAME_INFO  * _source)
  {
  _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->Name);
  }

  /* routine that frees graph for struct _LSAPR_TRUSTED_CONTROLLERS_INFO */
void _fgs__LSAPR_TRUSTED_CONTROLLERS_INFO (LSAPR_TRUSTED_CONTROLLERS_INFO  * _source)
  {
  if (_source->Names !=0)
    {
      {
      unsigned long _sym69;
      for (_sym69 = 0; _sym69 < (unsigned long )(0 + _source->Entries); _sym69++)
        {
        _fgs__LSAPR_UNICODE_STRING ((LSAPR_UNICODE_STRING *)&_source->Names[_sym69]);
        }
      }
    MIDL_user_free((void  *)(_source->Names));
    }
  }

  /* routine that frees graph for union _LSAPR_TRUSTED_DOMAIN_INFO */
void _fgu__LSAPR_TRUSTED_DOMAIN_INFO (LSAPR_TRUSTED_DOMAIN_INFO  * _source, TRUSTED_INFORMATION_CLASS _branch)
  {
  switch (_branch)
    {
    case TrustedDomainNameInformation :
      {
      _fgs__LSAPR_TRUSTED_DOMAIN_NAME_INFO ((LSAPR_TRUSTED_DOMAIN_NAME_INFO *)&_source->TrustedDomainNameInfo);
      break;
      }
    case TrustedControllersInformation :
      {
      _fgs__LSAPR_TRUSTED_CONTROLLERS_INFO ((LSAPR_TRUSTED_CONTROLLERS_INFO *)&_source->TrustedControllersInfo);
      break;
      }
    case TrustedPosixOffsetInformation :
      {
      break;
      }
    }
  }

