MessageId=3501 SymbolicName=NET3501
Language=English
EXPLANATION

You typed an invalid command option.

ACTION

To see a list of options for this command, type:

	NET HELP command

When typing commands, remember that most options must be preceded with a slash, as in /DELETE.

.
MessageId=3502 SymbolicName=NET3502
Language=English
EXPLANATION

The specified system error occurred.

ACTION

Correct the problem and retype the command.

.
MessageId=3503 SymbolicName=NET3503
Language=English
EXPLANATION

The command has an invalid number of options or variables.

ACTION

To see the syntax of this command, type:

	NET HELP command


.
MessageId=3504 SymbolicName=NET3504
Language=English
EXPLANATION

The command tried to perform multiple tasks and some of them could not be completed.

ACTION

No action is needed.

.
MessageId=3505 SymbolicName=NET3505
Language=English
EXPLANATION

You typed an incorrect value for a command option.

ACTION

To see the syntax of this command and its options, type:

     NET HELP command /OPTIONS

.
MessageId=3506 SymbolicName=NET3506
Language=English
EXPLANATION

The specified option is invalid.

ACTION

Check the spelling of the option you typed.

To see a list of options for this command, type:

	NET HELP command

.
MessageId=3507 SymbolicName=NET3507
Language=English
EXPLANATION

The specified option can be confused with other options.

ACTION

Type enough letters of the option so that it is unambiguous.
If the command has two options that both begin with /OPT, such as /OPT and /OPTION, you must type at least four letters to designate the second option.
To see a list of options for this command, type:

	NET HELP command

.
MessageId=3510 SymbolicName=NET3510
Language=English
EXPLANATION

You typed a command with two options that conflict, such as /YES and /NO.

ACTION

Retype the command without contradictory options.

.
MessageId=3511 SymbolicName=NET3511
Language=English
EXPLANATION

The specified program file could not be found.

ACTION

Check that the program is in the same directory as NET.EXE, which is usually in your system directory.

.
MessageId=3512 SymbolicName=NET3512
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The software you are attempting to run requires a more recent version of the operating system.

ACTION

Run the software using a more recent version of the operating system.

.
MessageId=3513 SymbolicName=NET3513
Language=English
EXPLANATION

Windows NT could not display all available data.

ACTION

The action required depends on the command that returned the error. Contact your network administrator.

.
MessageId=3515 SymbolicName=NET3515
Language=English
EXPLANATION

This command can be used only on a Windows NT Server system.

ACTION

Redo the operation on a Windows NT Server system.

.
MessageId=3533 SymbolicName=NET3533
Language=English
EXPLANATION

This task cannot be performed while the service is starting or stopping.

ACTION

Try the task later.


.
MessageId=3534 SymbolicName=NET3534
Language=English
EXPLANATION

The service did not report an error.

ACTION

Try the task later. If the problem persists, contact your network administrator.

.
MessageId=3547 SymbolicName=NET3547
Language=English
EXPLANATION

A service-specific error occurred.

ACTION

Refer to the Help or documentation for that service to determine the problem.

.
MessageId=3694 SymbolicName=NET3694
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You attempted to delete an active printer.

ACTION

After the current job has finished spooling, either print or delete the job. Then delete the printer.

.
MessageId=3710 SymbolicName=NET3710
Language=English
EXPLANATION

Windows NT could not find a file of Help information.

ACTION

Be sure the NET.HLP file is in the same directory as NET.EXE, which is usually in your system directory. This directory should also be on your search path (specified by the PATH command).

If you cannot find the Help file on your computer, contact your network administrator. Your administrator should copy the Help file from the Windows NT distribution disks to your computer.

.
MessageId=3711 SymbolicName=NET3711
Language=English
EXPLANATION

Help file, NET.HLP, is damaged. The file is usually in your system directory.

ACTION

Contact your network administrator. Your administrator should copy the Help file from the Windows NT distribution disks to your computer.

If the problem persists, contact technical support.

.
MessageId=3712 SymbolicName=NET3712
Language=English
EXPLANATION

Help file, NET.HLP, is damaged. The file is usually in your system directory.

ACTION

Contact your network administrator. Your administrator should copy the Help file from the Windows NT distribution disks to your computer.

If the problem persists, contact technical support.

.
MessageId=3713 SymbolicName=NET3713
Language=English
EXPLANATION

Either this domain does not have logon security and therefore does not have a domain controller, or its domain controller is currently unavailable.

ACTION

If this domain does not have logon security, you cannot use this domain. Otherwise, retry the command. If the problem persists, ask your network administrator if the domain controller is running.

.
MessageId=3714 SymbolicName=NET3714
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You must have administrative privilege on the remote computer to perform this task because that computer is running a previous version of LAN Manager.

ACTION

To complete this task, ask your administrator to give you administrative privilege on the remote computer, or have that computer upgraded to Windows NT.

.
MessageId=3716 SymbolicName=NET3716
Language=English
EXPLANATION

You typed an invalid device name.

ACTION

Check the spelling of the device name. Valid device names are LPT1: to LPT9: for printers and A: to Z: for disk devices.

.
MessageId=3717 SymbolicName=NET3717
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The log file you are using is damaged.

ACTION

If you may need to refer to this log file in the future, copy it to another filename, and then clear it so that you can start another one.

.
MessageId=3718 SymbolicName=NET3718
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Netrun service runs only programs with the filename extension .EXE.

ACTION

To use a program with a .COM extension, an administrator must rename it to a .EXE file.

.
MessageId=3719 SymbolicName=NET3719
Language=English
EXPLANATION

Windows NT could not find the resource you wanted to
stop sharing.

ACTION

Check the spelling of the share name.

To see a list of resources the server is sharing, type:

     NET SHARE

.
MessageId=3720 SymbolicName=NET3720
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The internal record of this user is invalid.

ACTION

Contact technical support.

.
MessageId=3721 SymbolicName=NET3721
Language=English
EXPLANATION

You used an incorrect password.

ACTION

Check that you have the correct password, and then retype it.

If you cannot remember your password, see your network administrator to have your password changed.

.
MessageId=3722 SymbolicName=NET3722
Language=English
EXPLANATION

An error occurred when a message was sent to the alias you selected. An additional error message should follow this one. It will tell you what action to take to correct the error.

ACTION

Follow the recommended action in the second error message.

.
MessageId=3723 SymbolicName=NET3723
Language=English
EXPLANATION

Either your password or your user name is incorrect.

ACTION

Retry the operation with the correct password or user name.

If you cannot remember your password, see your network administrator to have your password changed.

.
MessageId=3725 SymbolicName=NET3725
Language=English
EXPLANATION

An error occurred when Windows NT tried to stop sharing the resource.

ACTION

Try again to stop sharing the resource.

If no more information about this error is displayed, use Event Viewer to read the system log.


If no more information appears in Event Viewer and the problem persists, contact technical support.

.
MessageId=3726 SymbolicName=NET3726
Language=English
EXPLANATION

You typed an invalid user name.

ACTION

Retype the command with a valid user name.

.
MessageId=3727 SymbolicName=NET3727
Language=English
EXPLANATION

You typed an invalid password.

ACTION

Retype the command, using a valid password.

.
MessageId=3728 SymbolicName=NET3728
Language=English
EXPLANATION

The two passwords you typed did not match.

ACTION

Be sure to type identical passwords.

.
MessageId=3729 SymbolicName=NET3729
Language=English
EXPLANATION

Loading of the profile stopped after an error occurred.

ACTION

No action is needed.

.
MessageId=3730 SymbolicName=NET3730
Language=English
EXPLANATION

You typed an invalid computer name or domain.

ACTION

Retype the command with a valid computer name or domain. If you need further assistance, contact your network administrator.

.
MessageId=3734 SymbolicName=NET3734
Language=English
EXPLANATION

You typed an invalid password.

ACTION

Type a valid password.

.
MessageId=3735 SymbolicName=NET3735
Language=English
EXPLANATION

You typed an invalid name.

ACTION

Type a valid name.

.
MessageId=3736 SymbolicName=NET3736
Language=English
EXPLANATION

You cannot share this resource.

ACTION

No action is needed.

.
MessageId=3738 SymbolicName=NET3738
Language=English
EXPLANATION

This command is valid only for device names of printers and communication devices.

ACTION

No action is needed.

.
MessageId=3742 SymbolicName=NET3742
Language=English
EXPLANATION

You typed an invalid user name or group name.

ACTION

Check the spelling of the user or group name. To see a list of existing users, type:

     NET USER

To see a list of existing local groups, type:

     NET LOCALGROUP

To see a list of existing global groups, type:

     NET GROUP

.
MessageId=3743 SymbolicName=NET3743
Language=English
EXPLANATION

The server is not set up to be administered remotely.

ACTION

For the server to be administered remotely, you must share the server's ADMIN$ and IPC$ resources.

.
MessageId=3752 SymbolicName=NET3752
Language=English
EXPLANATION

No users have sessions with this server.

ACTION

No action is needed.

.
MessageId=3753 SymbolicName=NET3753
Language=English
EXPLANATION

This user is not a member of the group.

ACTION

No action is needed.

.
MessageId=3754 SymbolicName=NET3754
Language=English
EXPLANATION

This user is already a member of the group.

ACTION

No action is needed.

.
MessageId=3755 SymbolicName=NET3755
Language=English
EXPLANATION

You typed an unknown user name.

ACTION

Check the spelling of the user name and then retype the command.

.
MessageId=3757 SymbolicName=NET3757
Language=English
EXPLANATION

You did not provide a valid response to a Windows NT prompt.

ACTION

Type a valid response.

.
MessageId=3760 SymbolicName=NET3760
Language=English
EXPLANATION

The day you specified is invalid. Valid days are Monday, Tuesday, Wednesday, Thursday, Friday, Saturday, and Sunday.

Valid abbreviations are M, T, W, Th, F, Sa, and Su.

ACTION

Retype the command, using valid names or abbreviations.

.
MessageId=3761 SymbolicName=NET3761
Language=English
EXPLANATION

You specified a time range that starts later than it ends.
Time ranges must start and end on the same day.

ACTION

Retype the command with a valid time range.

You can use either the 12-hour or the 24-hour time format. When you use the 12-hour format, you must specify either AM or PM for each time.

When you use the 24-hour format, do not specify AM or PM.

.
MessageId=3762 SymbolicName=NET3762
Language=English
EXPLANATION

You specified an hour in a format that could not be recognized. The hour can be a number from 0 to 12 in 12-hour format or 0 to 24 in 24-hour format. If you use the 12-hour format, you must specify either AM or PM for each time.

ACTION

Retype the command with the correct hour format.

.
MessageId=3763 SymbolicName=NET3763
Language=English
EXPLANATION

You specified the minutes in a format that could not be recognized.

Typing the minutes is optional, but if included, the format must be :00 (a colon and two zeros).

ACTION

Retype the command, either omitting the minutes or using the correct format (:00).

.
MessageId=3764 SymbolicName=NET3764
Language=English
EXPLANATION


Specifying minutes in your logon command is optional, but if included, the minutes must be in the format :00 (a colon and two zeros).

ACTION

Retype the command, either omitting the minutes or using the correct format (:00).

.
MessageId=3765 SymbolicName=NET3765
Language=English
EXPLANATION

You mixed 12- and 24-hour formats in your time specification.

If you use the 12-hour format (with AM and PM), the hours must be from 0 to 12. If you use 24-hour format, the hours must be from 0 to 24.

ACTION

Retype the command with either the 12- or 24-hour format.

.
MessageId=3766 SymbolicName=NET3766
Language=English
EXPLANATION

You tried to use the 12-hour format, but the time was followed by text that was neither AM nor PM.

If you use the 12-hour format, you must follow each time with either AM, A.M., PM, or P.M.

ACTION

Retype the command with the correct forms of AM and PM.

.
MessageId=3767 SymbolicName=NET3767
Language=English
EXPLANATION

You used an illegal date format.

ACTION

Retype the command with a correct date format.

Dates should be typed in the form mm/dd/yy or dd/mm/yy, depending on the user's
country code. Months can be represented by a number, spelled out, or 
abbreviated to exactly 3 letters. Use commas or slashes to separate the parts 
of the date--do not use spaces. If you do not specify the year, Windows NT 
assumes it to be the next occurrence of the date.

.
MessageId=3768 SymbolicName=NET3768
Language=English
EXPLANATION

You specified an illegal range of days.

You must also type a hyphen between the first and last days of each range.

ACTION

When specifying days, use only the complete names of
the days or valid Windows NT abbreviations. Valid abbreviations are:

     M, T, W, Th, F, Sa, Su

Use a hyphen to separate the beginning and
end of each range of days.

.
MessageId=3769 SymbolicName=NET3769
Language=English
EXPLANATION

You typed an invalid time range.

ACTION

Retype the command with a valid time range. Use either the 12-hour format, with the numbers 0-12 and AM and PM, or the 24-hour format, with the numbers 0-24.

Use a hyphen to separate the beginning and end of a time range, as in 9AM-4PM.

.
MessageId=3770 SymbolicName=NET3770
Language=English
EXPLANATION

You typed invalid options or variables with the command.

ACTION

Retype the command, using valid options and variables.

When you add a user account, the password you set for the user must conform to your system's guidelines for password length.

.
MessageId=3771 SymbolicName=NET3771
Language=English
EXPLANATION

The /ENABLESCRIPT option of the NET USER command accepts only YES as a value.

ACTION

Retype the command, either specifying /ENABLESCRIPT:YES or not specifying /ENABLESCRIPT.

.
MessageId=3773 SymbolicName=NET3773
Language=English
EXPLANATION

You typed an invalid country code.

ACTION

Specify a valid country code.

.
MessageId=3774 SymbolicName=NET3774
Language=English
EXPLANATION

The user was successfully created but could not be added to the USERS local group.

ACTION

Try deleting the user. Then add the user to the local group again. If the problem persists, contact technical support.

.
MessageId=3775 SymbolicName=NET3775
Language=English
EXPLANATION

The user context you supplied with /USER is invalid.

ACTION

Retype the command with a valid user context which may be a simple user name or a qualified user name (in the form DOMAIN\USERNAME).

.
MessageId=3776 SymbolicName=NET3776
Language=English
EXPLANATION

A system dynamic-link library could not be loaded.

ACTION

Make sure the file specified is in your system directory. If it is not, contact your network administrator.

.
MessageId=3777 SymbolicName=NET3777
Language=English
EXPLANATION

The NET SEND command no longer sends files.

ACTION

Type the message you wish to send on the same line as NET SEND.

.
MessageId=3778 SymbolicName=NET3778
Language=English
EXPLANATION

When you are creating the special shares IPC$ or ADMIN$, you may not specify a path.

ACTION

Retype the command without a path. For example, NET SHARE ADMIN$.

.
MessageId=3779 SymbolicName=NET3779
Language=English
EXPLANATION

The account (user or global group) is already in the local group you are trying to add it to.

ACTION

No action is needed.

.
MessageId=3780 SymbolicName=NET3780
Language=English
EXPLANATION

The user or group specified does not exist.

ACTION

Retype the command with a correct user name or group name.

.
MessageId=3781 SymbolicName=NET3781
Language=English
EXPLANATION

The computer account specified does not exist.

ACTION

Retype the command with a correct computer name.

.
MessageId=3782 SymbolicName=NET3782
Language=English
EXPLANATION

The computer account specified already exists.

ACTION

Choose a different computer name.

.
MessageId=3783 SymbolicName=NET3783
Language=English
EXPLANATION

The global user or group specified does not exist.

ACTION

Retype the command with a correct user name or group name.

.
MessageId=3790 SymbolicName=NET3790
Language=English
EXPLANATION

The system could not find the message.

ACTION

Contact your system administrator.

.
MessageId=3802 SymbolicName=NET3802
Language=English
EXPLANATION

You typed an invalid schedule date.

ACTION

Specify either a day of the month represented by a number between 1 and 31, or a day of the week represented by one of the following abbreviations: M, T, W, Th, F, Sa, Su.

.
MessageId=3803 SymbolicName=NET3803
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The root directory for LAN Manager is unavailable.

ACTION

Be sure the workstation is running and the directory
containing the LAN Manager software is accessible.

.
MessageId=3804 SymbolicName=NET3804
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Either the SCHED.LOG file has been opened by another process or the disk is full.

ACTION

Be sure the disk is not full.

If another process has opened the file, you will have to wait for it to close the file before you can open it.

.
MessageId=3805 SymbolicName=NET3805
Language=English
EXPLANATION

The Server service must be running for this command to run.

ACTION

Start the server, and then retype the command.

.
MessageId=3806 SymbolicName=NET3806
Language=English
EXPLANATION

You specified a job identification number that does not exist.

ACTION

To see the list of jobs and identification numbers in the schedule file, type:

     AT

.
MessageId=3807 SymbolicName=NET3807
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The schedule file is damaged.

ACTION

Restore the schedule file, SCHED.LOG, from a backup copy, or delete the file and create a new one with the AT utility. SCHED.LOG is in the LANMAN\LOGS directory.

.
MessageId=3808 SymbolicName=NET3808
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager cannot find the job you are trying to delete.

ACTION

Check the job identification number by typing:

     AT

Try again to delete the job, using the correct job identification number.

If the error persists, the schedule file, SCHED.LOG, may be damaged. Restore SCHED.LOG from a backup copy, or delete it and create a new one with the AT utility. SCHED.LOG is in the LANMAN\LOGS directory.

.
MessageId=3809 SymbolicName=NET3809
Language=English
EXPLANATION

Commands used with the AT utility cannot exceed 259 characters.

ACTION

Type a command with 259 or fewer characters.

.
MessageId=3810 SymbolicName=NET3810
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot update the schedule file because the disk is
full.

ACTION

Make room on the disk by deleting unnecessary files.

.
MessageId=3812 SymbolicName=NET3812
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The schedule file has been damaged, possibly by system errors.

ACTION

Restore the schedule file, SCHED.LOG, from a backup copy, or delete the file and create a new one with the AT utility. SCHED.LOG is in the LANMAN\LOGS directory.

.
MessageId=3813 SymbolicName=NET3813
Language=English
EXPLANATION

The schedule file was cleared.

ACTION

No action is needed.

.
MessageId=3815 SymbolicName=NET3815
Language=English
EXPLANATION

The command could not be completed because another scheduled command is currently running.

ACTION

Try the command later.

.
MessageId=3816 SymbolicName=NET3816
Language=English
EXPLANATION

The minimum password age specified must not be greater than the maximum.

ACTION

Specify a minimum password age that is less than the maximum password age.

.
MessageId=3817 SymbolicName=NET3817
Language=English
EXPLANATION

User account values cannot be replicated to down-level servers unless the account values are compatible with the down-level server's values.

ACTION

No action is needed.

.
MessageId=3870 SymbolicName=NET3870
Language=English
EXPLANATION

The computer name you specified is invalid.

ACTION

Check the spelling of the computer name.

.
MessageId=3871 SymbolicName=NET3871
Language=English
EXPLANATION

The specified message number does not represent a Windows NT message.

ACTION

Check that you typed the correct message number. To see more information about system messages, type:

    NET HELPMSG message#

where message# is the message number.

.
MessageId=3913 SymbolicName=NET3913
Language=English
EXPLANATION

Either this domain does not have logon security and therefore does not have a domain controller, or its domain controller is unavailable.

ACTION

If this domain does not have logon security, you cannot use this command. Otherwise, retry the command. If the problem persists, ask your network administrator if the domain controller is running.

.
MessageId=3915 SymbolicName=NET3915
Language=English
EXPLANATION

The system could not determine your home directory.

ACTION

Ask your network administrator to add a home directory for you.

.
MessageId=3916 SymbolicName=NET3916
Language=English
EXPLANATION

The system could not determine your home directory.

ACTION

Ask your network administrator to add a home directory for you.

.
MessageId=3917 SymbolicName=NET3917
Language=English
EXPLANATION

Your home directory is not a network path that can be connected to. The directory must specify a full path, including the server and share names.

ACTION

Ask your network administrator to verify that the home directory path specified in the user account is correct.

.
MessageId=3932 SymbolicName=NET3932
Language=English
EXPLANATION

The name you specified is not a valid domain or workgroup name.

ACTION

Check the spelling of the name. Retype the command with a valid domain or workgroup name.

.
MessageId=3951 SymbolicName=NET3951
Language=English
EXPLANATION

You specified too many values for the listed option.

ACTION

Retype the command with the correct number of values. To see the syntax of this command, type:

     NET HELP command

.
MessageId=3952 SymbolicName=NET3952
Language=English
EXPLANATION

You typed an invalid value for the listed option.

ACTION

Retype the command with valid values. To see the syntax of this command, type:

     NET HELP command

.
MessageId=3953 SymbolicName=NET3953
Language=English
EXPLANATION

You did not use the correct syntax of this command.

ACTION

To see the syntax of this command, type:

     NET HELP command

.
MessageId=3960 SymbolicName=NET3960
Language=English
EXPLANATION

The file identification number you specified is either outside the valid range or is nonnumeric.

ACTION

Retype the command with a valid file identification number. To see a list of the server's open files and their identification numbers, type:

     NET FILE

.
MessageId=3961 SymbolicName=NET3961
Language=English
EXPLANATION

The print job identification number you specified is either outside the valid range or is nonnumeric.

ACTION

Retype the command with a valid print job identification number. To see a list of a server's print jobs, type:

     NET PRINT \\computername\sharename


.
MessageId=3963 SymbolicName=NET3963
Language=English
EXPLANATION

The user or group account you typed does not exist.

ACTION

Retype the command, specifying an existing account.
.
MessageId=3100 SymbolicName=NET3100
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3101 SymbolicName=NET3101
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The system required more of a resource than was available.

ACTION

Change the value of the listed option in the configuration file to allow the system to access more of the resource.

.
MessageId=3102 SymbolicName=NET3102
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3103 SymbolicName=NET3103
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3104 SymbolicName=NET3104
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3105 SymbolicName=NET3105
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3106 SymbolicName=NET3106
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3107 SymbolicName=NET3107
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A program or command could not run because LAN Manager
is not started or installed.

ACTION

Check that LAN Manager is installed and that the Workstation service is started. Then type the command again.

.
MessageId=3108 SymbolicName=NET3108
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3109 SymbolicName=NET3109
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3110 SymbolicName=NET3110
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3111 SymbolicName=NET3111
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3112 SymbolicName=NET3112
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3113 SymbolicName=NET3113
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3114 SymbolicName=NET3114
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The error log is full, and one or more error log entries have been lost.

ACTION

If you want to save the current error log file, copy it to another filename. Then clear the error log. You may do this remotely with Event Viewer.

.
MessageId=3120 SymbolicName=NET3120
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server's main information segment is larger than the
largest segment that can be allocated.

ACTION

Decrease the values for one or more of the following entries in the server's configuration file:

      MAXCHDEVJOB     MAXCONNECTIONS    MAXOPENS
      MAXCHDEVQ       MAXLOCKS          MAXSHARES
      MAXCHDEVS

Then restart the Server service.

.
MessageId=3121 SymbolicName=NET3121
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server cannot increase the size of a memory segment.

ACTION

Be sure that the MEMMAN entry in the server's CONFIG.SYS file allows swapping and that there is at least 1 megabyte of free space on the swap disk. The swap disk is specified by the SWAPPATH entry in the CONFIG.SYS file.

You could also decrease the value of the NUMBIGBUF entry
in the server's configuration file.

.
MessageId=3122 SymbolicName=NET3122
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The user accounts database, NET.ACC, is missing, damaged, or in a format that is incompatible with this version of LAN Manager.

ACTION

Copy the backup file, NETACC.BKP, to NET.ACC. If NETACC.BKP does not exist, copy NET.ACC or NETACC.BKP from a backup floppy or from the LAN Manager distribution disks.

If you have upgraded your LAN Manager software, you may need
to convert the user accounts database to a new format. See the instructions that came with your upgrade.

.
MessageId=3123 SymbolicName=NET3123
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
All networks named in the SRVNETS entry of the server's configuration file must use the LAN Manager workstation software.

ACTION

Be sure that all networks named in the SRVNETS entry of the server's configuration file are also named in the WRKNETS entry of that file.

.
MessageId=3124 SymbolicName=NET3124
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The configuration entries CHARWAIT, CHARTIME, and CHARCOUNT must all be zero or must all have non-zero values.

ACTION

Correct the entries and restart the Server service.

.
MessageId=3125 SymbolicName=NET3125
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server received an invalid request to run a command. The request may have been damaged by the network.

ACTION

No action is needed.

If this error occurs frequently, contact technical support.

.
MessageId=3126 SymbolicName=NET3126
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server found a resource shortage in a network driver
when it tried to issue a network control block (NCB).

ACTION

Be sure that the NETn entries in the configuration file specify valid NetBIOS device drivers and that these device drivers are in the LANMAN\DRIVERS directory. Also be sure that the CONFIG.SYS file contains a DEVICE line specifying the absolute paths

of the device drivers.

You may be able to increase the NCBs for the listed network by changing an option in the network's NETn entry in the configuration file. See the installation guide that came with your network adapter for information about those options.

If you need assistance, contact your network administrator.

.
MessageId=3127 SymbolicName=NET3127
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server cannot respond to a ReleaseMemory alert. Otherwise, the server is functioning normally.

ACTION

No action is needed.

.
MessageId=3128 SymbolicName=NET3128
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server cannot respond to a ReleaseMemory alert. Otherwise, the server is functioning normally.

ACTION

No action is needed.

.
MessageId=3129 SymbolicName=NET3129
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The schedule file, SCHED.LOG, in the LOGS directory, is damaged.

ACTION

Restore the schedule file from a backup copy, or delete the file and create a new one using the AT utility.

.
MessageId=3130 SymbolicName=NET3130
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server could not find the NET.MSG file.

ACTION

The NET.MSG file should be in the LANMAN\NETPROG directory. If it is not there, copy it from the LAN Manager distribution disks.

.
MessageId=3131 SymbolicName=NET3131
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
There is not enough memory available to run the Server service.

ACTION

Stop other applications and services (except the Workstation service) that are running on the computer and try again. If the problem continues, you will have to add memory to the computer.

.
MessageId=3132 SymbolicName=NET3132
Language=English
EXPLANANTION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server was unable to access required memory.

ACTION

Be sure there is at least 1 megabyte of free space on the swap disk. The swap disk is specified by the SWAPPATH entry in the CONFIG.SYS file. Then restart the computer and try to start the Server service again.

.
MessageId=3140 SymbolicName=NET3140
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3141 SymbolicName=NET3141
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3150 SymbolicName=NET3150
Language=English

.
MessageId=3151 SymbolicName=NET3151
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Messenger service could not display a message because an error occurred while the message box was being created.

ACTION

If message logging was on, the message was still logged to
the file and can be viewed by displaying or printing the message log file.

.
MessageId=3152 SymbolicName=NET3152
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.


.
MessageId=3160 SymbolicName=NET3160
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The workstation's main information segment is larger than
the largest segment that can be allocated.

ACTION

Decrease the values for one or more of the following entries in the [workstation] section of the configuration file. If you need assistance, contact your network administrator.

     MAXCMDS       NUMCHARBUF     NUMWORKBUF
     MAXTHREADS    NUMDGRAMBUF    SIZCHARBUF     NUMALERTS     NUMSERVICES    SIZERROR

After you change the configuration file, restart the Workstation service. If you change the MAXCMDS or MAXTHREADS entry, you will have to restart the computer.

.
MessageId=3161 SymbolicName=NET3161
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3162 SymbolicName=NET3162
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3163 SymbolicName=NET3163
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Workstation service may have been started improperly. Always use the NET START command to start the workstation; do not run WKSTA.EXE directly.

ACTION

To start the Workstation service, type:

	NET START WORKSTATION

If more problems occur, contact technical support.

.
MessageId=3164 SymbolicName=NET3164
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The internal table that maintains information about network servers is full. You can access all network servers normally, but you may not be able to see all servers when you type the NET VIEW command.

This happens only on very large networks.

ACTION

Contact your network administrator. Your administrator may want to divide the network into domains, using the DOMAIN entry in each computer's configuration file.

.
MessageId=3165 SymbolicName=NET3165
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3166 SymbolicName=NET3166
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Workstation service failed to start the user accounts database.

ACTION

Contact technical support.

.
MessageId=3167 SymbolicName=NET3167
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3170 SymbolicName=NET3170
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3171 SymbolicName=NET3171
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An error occurred when LAN Manager tried to identify the members of the specified group. The group is probably too large.

ACTION

Split the group into two or more smaller groups.

.
MessageId=3172 SymbolicName=NET3172
Language=English
EXPLANATION

An error occurred when an alert message was sent. The user name designated to receive the alert may no longer exist.

ACTION

Use Server Manager to repair the error.

.
MessageId=3173 SymbolicName=NET3173
Language=English
EXPLANATION

A software error occurred.

ACTION

Verify that the Alerter service has been started. If the service has already been started, contact technical support.

.
MessageId=3174 SymbolicName=NET3174
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager cannot read the schedule file because the file is damaged.

ACTION

Restore the schedule file from a backup copy, if you have one. If not, delete the file and create a new one with the AT utility.

.
MessageId=3175 SymbolicName=NET3175
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The schedule file contains a record with an invalid format.

ACTION

Restore the schedule file from a backup copy. If you do not have one, delete the AT schedule file and create a new one with the AT utility.

.
MessageId=3176 SymbolicName=NET3176
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server created a schedule file.

ACTION

No action is needed.

.
MessageId=3177 SymbolicName=NET3177
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server could not start one of its networks.

ACTION

Be sure that each network listed in the SRVNETS entry in the server's configuration file has a corresponding entry in the [networks] section of the configuration file.

.
MessageId=3178 SymbolicName=NET3178
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You used the AT utility to specify a program that could not run.

ACTION

Check the filename of the program you tried to schedule. If it is in a directory that is not on the computer's search path, be sure to specify its full path.

Be sure that all programs you schedule are executable.

.
MessageId=3180 SymbolicName=NET3180
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An error occurred when the lazy-write process tried to write to the specified hard disk.

ACTION

Run CHKDSK on the specified drive to check for problems with the disk or the files affected by the lazy-write process.

.
MessageId=3181 SymbolicName=NET3181
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The fault-tolerance system found a bad disk sector and rerouted data to a good sector (this is called hotfixing). No data was lost.

ACTION

Run CHKDSK soon to ensure that enough good disk sectors are available for hotfixing.

.
MessageId=3182 SymbolicName=NET3182
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An error occurred during an operation on the listed disk because of problems with the disk. The operation probably did not succeed.

ACTION

Retry the operation. If the problem persists and you are unable to recover data from the disk, use backups of the affected files, if you have any.

.
MessageId=3183 SymbolicName=NET3183
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The user accounts database file is damaged, so the backup file made at the listed date is now being used. Changes made to the user accounts database since this time were lost. Local security is still in effect.

ACTION

To update the user accounts database, retype changes made to it since the listed date.

.
MessageId=3184 SymbolicName=NET3184
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The user accounts database file is missing, so the backup file made at the listed date is now being used. Changes made to the user accounts database since this time were lost. Local security is still in effect.

ACTION

To update the user accounts database, retype changes made to it since the listed date.

.
MessageId=3185 SymbolicName=NET3185
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Local security could not start because the user accounts database file, NET.ACC, is missing or damaged and no backup file exists on the hard disk.

ACTION

Restore NET.ACC from a backup. The backup file will be named either NET.ACC or NETACC.BKP. Then restart the computer.

If there is no backup, reinstall LAN Manager using the Setup program.

.
MessageId=3186 SymbolicName=NET3186
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Local security could not start because of the listed error.

ACTION

Find and correct the cause of the listed error, and then restart the computer.

.
MessageId=3190 SymbolicName=NET3190
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=3191 SymbolicName=NET3191
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The workstation is out of the specified resource.

ACTION

Adjust the workstation's configuration file to increase the amount of this resource. If you need assistance, contact your network administrator.

.
MessageId=3192 SymbolicName=NET3192
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An error occurred on a request that was sent to the specified
server. The workstation may have been connected to a resource that is no longer shared.

ACTION

Ask a network administrator to reshare the resource so that you can use it.

If this solution fails, contact technical support.

.
MessageId=3193 SymbolicName=NET3193
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The connection between your workstation and the specified server was unexpectedly broken. The server may have been restarted or a network problem may have occurred.

ACTION

If the server was restarted, retry the operation to reestablish the connection.

If you need more assistance, contact technical support.
This message displays a network control block (NCB) value and the NCB error that was returned. Save this information for technical support.

.
MessageId=3194 SymbolicName=NET3194
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The session with the specified server was ended because the server stopped responding.

ACTION

Ask your network administrator if the server is running. If so, reconnect to the server.

The amount of time a workstation waits for a server
to respond to a request is determined by the SESSTIMEOUT entry in the workstation's configuration file. If your sessions with servers are frequently ended by this error, you may want to increase the value of SESSTIMEOUT. 
If you need assistance, contact your administrator.

.
MessageId=3195 SymbolicName=NET3195
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An unexpected network control block (NCB) error occurred
on the session with the specified server. The server may have been restarted, or a network problem may have occurred.

ACTION

Ask your network administrator if the server was recently restarted.

If you need more assistance, contact technical support. This message displays an NCB value and the NCB error that was returned. Save this information for technical support.

.
MessageId=3196 SymbolicName=NET3196
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An attempt to write data to a file failed.

ACTION

See if the specified disk is full. Also be sure that you have write permission for the target file.

.
MessageId=3197 SymbolicName=NET3197
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The specified NetBIOS driver found a problem that
required the network adapter card to be reset. Resetting the card did not solve the problem.

ACTION

Contact technical support.

.
MessageId=3198 SymbolicName=NET3198
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The amount of the listed resource requested was more than the maximum. The maximum amount was allocated.

ACTION

Ask your network administrator check the workstation's configuration.

.
MessageId=3204 SymbolicName=NET3204
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server was unable to create a thread.

ACTION

Increase the value of the THREADS entry in the server's CONFIG.SYS file. The range for this value is 64 to 512.

.
MessageId=3205 SymbolicName=NET3205
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server found an error while closing the listed file.

ACTION

The file may be damaged. If it is, restore it from a backup copy.

.
MessageId=3206 SymbolicName=NET3206
Language=English
EXPLANATION

A directory cannot be replicated when it is the current directory of a process and its value for INTEGRITY is TREE.

ACTION

For the directory to be replicated, be sure it is not the current directory of any process.

.
MessageId=3207 SymbolicName=NET3207
Language=English
EXPLANATION

This server found that another server is exporting the listed directory to the listed import server.

ACTION

Be sure that only one computer is configured as the export server of this directory for the listed import computer. Check the EXPORTLIST and EXPORTPATH entries in the configuration files of the export servers and the IMPORTLIST and IMPORTPATH entries
 in

 the configuration file of the import server.

.
MessageId=3208 SymbolicName=NET3208
Language=English
EXPLANATION

An error prevented this server from updating the listed directory from the export server. The directory cannot be updated until the problem is corrected.

ACTION

Copy the files manually, if necessary, and investigate the cause of the listed error.

.
MessageId=3209 SymbolicName=NET3209
Language=English
EXPLANATION

This server's Replicator service lost contact with
the export server for the listed directory.

ACTION

Be sure the Server and Replicator services are running on the export server.

.
MessageId=3210 SymbolicName=NET3210
Language=English
EXPLANATION

This server was denied access to the security database by the domain controller. Until this problem is corrected, the server cannot synchronize user account information with the domain controller.

ACTION

Stop and restart the Netlogon service at this server.

.
MessageId=3211 SymbolicName=NET3211
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Replicator service was denied access to the listed export server. Until this problem is corrected, the replicator cannot update the local copies of files exported by that server.

ACTION

Be sure that the local computer has an account on the export server. 
The user name and password for this account are specified by the LOGON and PASSWORD entries in the local computer's configuration file. If there is no LOGON entry, then the local computer name is the user name and no password is necessary.

.
MessageId=3212 SymbolicName=NET3212
Language=English
EXPLANATION

The Replicator service stopped because the listed Windows NT error occurred.

ACTION

To see more information about the error, type:

     NET HELPMSG message#

where message# is the error number.

.
MessageId=3213 SymbolicName=NET3213
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A directory that is being replicated can have no more than 200 files.

ACTION

Remove files from the directory until 200 or fewer remain.

.
MessageId=3214 SymbolicName=NET3214
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The replication tree can be no more than 32 levels deep.

ACTION

Reorganize the replicated directories so that no path is more than 32 levels deep.

.
MessageId=3215 SymbolicName=NET3215
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3216 SymbolicName=NET3216
Language=English
EXPLANATION

The Replicator service stopped because the listed system error occurred.

ACTION

Check the cause of the system error.

.
MessageId=3217 SymbolicName=NET3217
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The computer cannot update its copies of the replicated files while a user is logged on and the TRYUSER option is set to NO.

ACTION

No action is needed. The computer will update the files when no user is logged on.

To have the local computer update files while users are logged on, change the value of the TRYUSER entry in the [replicator] section of the configuration file to YES.

.
MessageId=3218 SymbolicName=NET3218
Language=English
EXPLANATION

The import path specified either from the command line or in the configuration file, does not exist.

ACTION

Check the spelling of the IMPORTPATH entry in the configuration file. This entry must specify a directory that exists.

.
MessageId=3219 SymbolicName=NET3219
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The specified export path does not exist.

ACTION

Check the spelling of the EXPORTPATH entry in the configuration file. This entry must specify a directory that exists.

.
MessageId=3220 SymbolicName=NET3220
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The listed system error caused the Replicator service to fail to update its status.

ACTION

Check the cause of the system error.

.
MessageId=3221 SymbolicName=NET3221
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An error was recorded by the fault-tolerance system.
The error is explained in the original error message.

ACTION

Follow the action recommended in the original message.

.
MessageId=3222 SymbolicName=NET3222
Language=English
EXPLANATION

Because of the listed system error, the Replicator service could not access a file on the listed export server.

ACTION

Be sure the Replicator service's account on the export server has permission to read the directories being replicated. The name of this account can be displayed and changed using the Services option in Control Panel.


.
MessageId=3223 SymbolicName=NET3223
Language=English
EXPLANATION

The domain controller for this domain has stopped.

ACTION

Wait a few minutes and then restart the domain controller.

If this is not possible, you have the option of promoting another server to be the domain controller.

.
MessageId=3224 SymbolicName=NET3224
Language=English
EXPLANATION

This server found an error while changing the computer's password at the domain controller.

ACTION

If you are using Windows NT Workstation, ask your network administrator to set your computer value back to the default value. Then, using the Network option in Control Panel, leave and rejoin the domain.
If you are using Windows NT Server, use the Synchronize With Domain option in Server Manager to synchronize the servers.

.
MessageId=3225 SymbolicName=NET3225
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The current logon statistics may not be accurate because an error occurred while logon and logoff information was being updated.

ACTION

No action is needed.

.
MessageId=3226 SymbolicName=NET3226
Language=English
EXPLANATION

The local copy of the security database may be out of synchronization with that of the domain controller because an error occurred while the database was being updated.

ACTION

Use the Synchronize With Domain option in Server Manager to synchronize the security databases.


.
MessageId=3230 SymbolicName=NET3230
Language=English
EXPLANATION

The server had a power failure.

ACTION

The UPS service is shutting down the server. Stop applications that are running on the server and
have users disconnect from the server.

.
MessageId=3231 SymbolicName=NET3231
Language=English
EXPLANATION

The UPS battery is low, probably because of an extended power outage.

ACTION

No action is needed. The system will start automatically when power is restored.

.
MessageId=3232 SymbolicName=NET3232
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The UPS service could not finish running the specified command file in less than 30 seconds.

ACTION

Modify the contents of the command file so that it can be completed in 30 seconds or less.

.
MessageId=3233 SymbolicName=NET3233
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The UPS service could not access the UPS driver (UPSDRV.OS2). The UPS driver might not be configured properly.

ACTION

Be sure that your CONFIG.SYS file has a DEVICE line specifying the location of the UPS device driver and that the /PORT option of that line specifies the serial port that the battery is connected to.

If you make changes to CONFIG.SYS, you must restart your system for them to take effect.

.
MessageId=3250 SymbolicName=NET3250
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Remoteboot service could not start because the listed entry was missing from the configuration file.

ACTION

Add the listed entry to the server's configuration file.

.
MessageId=3251 SymbolicName=NET3251
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Remoteboot service could not start because of an invalid line in the listed configuration file.

ACTION

Check the listed line.

.
MessageId=3252 SymbolicName=NET3252
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Remoteboot service failed to start because of an error in the listed configuration file.

ACTION

Check the listed file.

.
MessageId=3253 SymbolicName=NET3253
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The listed file was changed after the Remoteboot service was started. Loading the boot-block stopped temporarily.

ACTION

Stop and restart the Remoteboot service.

.
MessageId=3254 SymbolicName=NET3254
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The files in the listed boot-block definition file do not fit in the boot block.

ACTION

Change the order of the files or the value of BASE or ORG.

.
MessageId=3255 SymbolicName=NET3255
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Remoteboot service could not start because the listed dynamic-link library returned the incorrect version number.

ACTION

Be sure you are using the correct versions of the dynamic-link libraries.

.
MessageId=3256 SymbolicName=NET3256
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An unrecoverable error occurred because of a problem with the dynamic-link library of the Remoteboot service.

ACTION

Be sure you are using the correct versions of the dynamic-link libraries.

.
MessageId=3257 SymbolicName=NET3257
Language=English
EXPLANATION

The system returned an unexpected error code. The error code
is in the data.

ACTION

Check the cause of the error.

.
MessageId=3258 SymbolicName=NET3258
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The fault-tolerance system error log is larger than 64K.

ACTION:

Run FTADMIN to fix any existing errors and clear them from the error log.

.
MessageId=3259 SymbolicName=NET3259
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server crashed while accessing the fault-tolerance error log, possibly damaging that log. The damaged fault-tolerance error log was cleared after its contents were backed up to LANMAN\LOGS\FT.ERR.

ACTION

No action is needed.
.
MessageId=3400 SymbolicName=NET3400
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The computer does not have enough memory available to start the Workstation service.

ACTION

Stop other applications that are running on the computer,  and then start the Workstation service again.



.
MessageId=3401 SymbolicName=NET3401
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager could not read the entries in the [networks] section of the LANMAN.INI file.

ACTION

Be sure that the LANMAN.INI file exists (in the LANMAN directory). Check the format of the entries in the [networks] section.

.
MessageId=3402 SymbolicName=NET3402
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The listed variable or option (from an entry in the [networks] section of the LANMAN.INI file) is invalid.

ACTION

Check the format of the entries in the [networks] section of the LANMAN.INI file.

.
MessageId=3403 SymbolicName=NET3403
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The listed entry in the [networks] section of the LANMAN.INI file has a syntax error.

ACTION

Check the format of the listed entry.

.
MessageId=3404 SymbolicName=NET3404
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The LANMAN.INI file cannot have more than 12 entries in the [networks] section.

ACTION

Remove entries from the [networks] section until 12 or fewer remain.

.
MessageId=3406 SymbolicName=NET3406
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The listed device driver could not be installed.

ACTION

Check that the listed entry in the [networks] section of the LANMAN.INI file is valid.

In the CONFIG.SYS file, check the DEVICE entry that loads this device driver--the parameters of that entry may not be correct.

Also check that the DEVICE entry specifies the correct path of the device driver.

.
MessageId=3407 SymbolicName=NET3407
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The device driver specified is incorrect. It may be incompatible with the network adapter card, or it may be out-of-date.

ACTION

Use a different device driver.

.
MessageId=3408 SymbolicName=NET3408
Language=English
EXPLANATION

Your computer has an incorrect version of the operating system.

ACTION

Upgrade your computer to the latest version of Windows NT.

.
MessageId=3409 SymbolicName=NET3409
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The redirector is already installed.

ACTION

No action is needed.

.
MessageId=3411 SymbolicName=NET3411
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The LAN Manager device driver NETWKSTA.SYS could not be installed.

ACTION

Another error message that contains a more detailed explanation of the error, should have been displayed prior to this message. See that message for the cause of the problem.

.
MessageId=3412 SymbolicName=NET3412
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An internal error occurred.

ACTION

Contact technical support.
.
MessageId=5300 SymbolicName=NET5300
Language=English
.
MessageId=5301 SymbolicName=NET5301
Language=English
.
MessageId=5302 SymbolicName=NET5302
Language=English
.
MessageId=5303 SymbolicName=NET5303
Language=English
.
MessageId=5304 SymbolicName=NET5304
Language=English
.
MessageId=5305 SymbolicName=NET5305
Language=English
EXPLANATION

A network control block (NCB) command to a remote computer failed because the remote computer did not respond in time. The remote computer is not listening. The session to the remote computer may have been dropped.

ACTION

No action is needed.

.
MessageId=5306 SymbolicName=NET5306
Language=English
.
MessageId=5307 SymbolicName=NET5307
Language=English
.
MessageId=5308 SymbolicName=NET5308
Language=English
.
MessageId=5309 SymbolicName=NET5309
Language=English
EXPLANATION

A network control block (NCB) request was refused. There is no space available on the network adapter card for another session.

ACTION

No action is needed.

.
MessageId=5310 SymbolicName=NET5310
Language=English
.
MessageId=5311 SymbolicName=NET5311
Language=English
.
MessageId=5312 SymbolicName=NET5312
Language=English
.
MessageId=5313 SymbolicName=NET5313
Language=English
.
MessageId=5314 SymbolicName=NET5314
Language=English
.
MessageId=5315 SymbolicName=NET5315
Language=English
.
MessageId=5316 SymbolicName=NET5316
Language=English
.
MessageId=5317 SymbolicName=NET5317
Language=English
EXPLANATION

The network control block (NCB) request was refused because the session table on the network adapter card was full.

ACTION

To allow more sessions, reconfigure the NetBIOS stack by changing the SESS value of the NETn entry in the configuration file. If you are using NetBEUI, you may also need to change the PROTOCOL.INI file.

.
MessageId=5318 SymbolicName=NET5318
Language=English
.
MessageId=5319 SymbolicName=NET5319
Language=English
.
MessageId=5320 SymbolicName=NET5320
Language=English
.
MessageId=5321 SymbolicName=NET5321
Language=English
.
MessageId=5322 SymbolicName=NET5322
Language=English
.
MessageId=5323 SymbolicName=NET5323
Language=English
.
MessageId=5324 SymbolicName=NET5324
Language=English
.
MessageId=5325 SymbolicName=NET5325
Language=English
.
MessageId=5326 SymbolicName=NET5326
Language=English

.
MessageId=5333 SymbolicName=NET5333
Language=English
.
MessageId=5334 SymbolicName=NET5334
Language=English
EXPLANATION

The maximum number of network control block (NCB) commands is outstanding. The command will be tried again later.

ACTION

No action is needed.

.
MessageId=5335 SymbolicName=NET5335
Language=English
.
MessageId=5336 SymbolicName=NET5336
Language=English
.
MessageId=5337 SymbolicName=NET5337
Language=English
.
MessageId=5338 SymbolicName=NET5338
Language=English

.
MessageId=5351 SymbolicName=NET5351
Language=English
.
MessageId=5352 SymbolicName=NET5352
Language=English
.
MessageId=5354 SymbolicName=NET5354
Language=English
.
MessageId=5356 SymbolicName=NET5356
Language=English

.
MessageId=5364 SymbolicName=NET5364
Language=English
.
MessageId=5365 SymbolicName=NET5365
Language=English
.
MessageId=5366 SymbolicName=NET5366
Language=English
.
MessageId=5367 SymbolicName=NET5367
Language=English
.
MessageId=5368 SymbolicName=NET5368
Language=English
.
MessageId=5369 SymbolicName=NET5369
Language=English
.
MessageId=5370 SymbolicName=NET5370
Language=English

.
MessageId=5380 SymbolicName=NET5380
Language=English
.
MessageId=5381 SymbolicName=NET5381
Language=English
.
MessageId=2102 SymbolicName=NET2102
Language=English
EXPLANATION

Windows NT is not installed, or your configuration file is incorrect.

ACTION

Install Windows NT, or see your network administrator about possible problems with your configuration file.

.
MessageId=2103 SymbolicName=NET2103
Language=English
EXPLANATION
This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server you specified does not exist.

ACTION

You may have misspelled the server's computer name. To see a list of servers in your domain, type:

	NET VIEW

Remember to precede computer names with two backslashes, as in \\computername.

.
MessageId=2104 SymbolicName=NET2104
Language=English
EXPLANATION
An internal error occurred.

ACTION

Contact technical support.

.
MessageId=2105 SymbolicName=NET2105
Language=English
EXPLANATION

The network hardware could not access the resources it
needed.

ACTION

Try the command again later.

.
MessageId=2106 SymbolicName=NET2106
Language=English
EXPLANATION

This operation can be performed only on a server.

ACTION

See your network administrator if you need more information.

.
MessageId=2107 SymbolicName=NET2107
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This device name is not assigned to a shared resource.

ACTION

Check the spelling of the device name first.

To see which local device names are assigned to shared resources, type:

     NET USE

.
MessageId=2114 SymbolicName=NET2114
Language=English
EXPLANATION

The specified server is not started. The server must be started before you can run this command.

ACTION

Use the Services option in Control Panel to start the Server service. Try the command again after the server has been started. If you need assistance, contact your network administrator.

.
MessageId=2115 SymbolicName=NET2115
Language=English
EXPLANATION

If you do not see your document listed, it has either completed printing, or the printer did not receive your document.

ACTION

No action is needed.

.
MessageId=2116 SymbolicName=NET2116
Language=English
EXPLANATION

You specified an unknown device or directory.

ACTION

Check the spelling of the device or directory name.


.
MessageId=2117 SymbolicName=NET2117
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The device name you specified is assigned to a shared resource.

ACTION

To perform this operation on this device name, you first must end its connection to the shared resource.

.
MessageId=2118 SymbolicName=NET2118
Language=English
EXPLANATION

This share name is already in use on this server.

ACTION

Choose a share name that is not currently used on this server. To see a list of resources currently shared on this server, type:

	NET SHARE

.
MessageId=2119 SymbolicName=NET2119
Language=English
EXPLANATION

The server could not access enough of a resource, such as memory, to complete this task.

ACTION

Try again later. If you continue to receive this message, stop some nonessential processes or applications and try to complete the task again. If you still have problems, your network administrator may need to reconfigure your system.

.
MessageId=2121 SymbolicName=NET2121
Language=English
EXPLANATION

The list of items in the command is too long.

ACTION

If your command included a list of items, split the list into two smaller lists. Type the command with the first list, and then again with the second list.


.
MessageId=2122 SymbolicName=NET2122
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
On a workstation running the Peer service, only you and one other user can have connections to a shared resource at the same time.

ACTION

Retype the command, specifying two as the maximum number of users for the resource.

.
MessageId=2123 SymbolicName=NET2123
Language=English
EXPLANATION

The program you are running created a buffer that is too
small for the data being used.

ACTION

The program should correct this problem. If it does not, see your network administrator or the vendor who supplied the program.

.
MessageId=2127 SymbolicName=NET2127
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The program or command you were running on a server could not be completed. There may be communication problems on the network, or the remote server may be short of resources.

ACTION

Contact your network administrator. Your administrator
should make sure that the server is configured with enough resources. Specifically, the NUMBIGBUF entry in the server's configuration file may need to be increased.

.
MessageId=2131 SymbolicName=NET2131
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The configuration file is missing or contains invalid
information.

ACTION

Ask your network administrator to review the contents of the configuration file.

.
MessageId=2136 SymbolicName=NET2136
Language=English
EXPLANATION

A general failure occurred in the network hardware. This problem may be due to a hardware conflict and could have been generated by any number of other Server service commands (for example, Replicator).

ACTION

See your network administrator. The problem could have occurred because of the hardware or software installed on your computer.

.
MessageId=2137 SymbolicName=NET2137
Language=English
EXPLANATION

The workstation is in an inconsistent state.

ACTION

Restart the computer.

.
MessageId=2138 SymbolicName=NET2138
Language=English
EXPLANATION

You have tried to use the network before starting the
Workstation service.

ACTION

Start the Workstation service by typing:

	NET START WORKSTATION

.
MessageId=2139 SymbolicName=NET2139
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Your command could not be completed because the MAILSLOTS entry of your workstation's configuration file is incorrect.

ACTION

Change the MAILSLOTS entry of the configuration file to YES. Then stop and restart the Workstation service.

.
MessageId=2140 SymbolicName=NET2140
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=2141 SymbolicName=NET2141
Language=English
EXPLANATION

The specified server is not configured to accept the command you typed.

ACTION

Ask your network administrator if the server is configured properly. The administrator may choose to share the server's IPC$ resource to correct this problem.

.
MessageId=2142 SymbolicName=NET2142
Language=English
EXPLANATION

The server does not support the request that was sent to it. This can happen if two or more versions of networking software are on the network. However, no program included with Windows NT should cause this error.

ACTION

Contact the vendor of the program that was running when the
error occurred.

.
MessageId=2143 SymbolicName=NET2143
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2144 SymbolicName=NET2144
Language=English
EXPLANATION

The computer name already exists on the network.

ACTION

Change the computer name and restart the computer before restarting
the Workstation service.

.
MessageId=2146 SymbolicName=NET2146
Language=English
EXPLANATION

Windows NT could not find the required information in your
configuration.

ACTION

Ask your network administrator to check your configuration.
The administrator should make sure your system configuration contains
all information required to run Windows NT and any associated applications.

.
MessageId=2147 SymbolicName=NET2147
Language=English
EXPLANATION

Windows NT could not find a particular entry in your
configuration.

ACTION

Ask your network administrator to check your configuration.
The administrator should make sure your system configuration contains
all information required to run Windows NT and any
associated applications.

.
MessageId=2149 SymbolicName=NET2149
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A line in the configuration file is too long.

ACTION

Edit the configuration file.

.
MessageId=2150 SymbolicName=NET2150
Language=English
EXPLANATION

The printer you have specified is invalid.

ACTION

Check the spelling of the printer name.

To see the list of printers shared on this server, type:

     NET VIEW \\computername

.
MessageId=2151 SymbolicName=NET2151
Language=English
EXPLANATION

There is no print job matching the print job identification number you typed.

ACTION

Be sure you typed the correct print job identification
number. To see a list of current print jobs, type:

	NET PRINT \\computername\sharename

.
MessageId=2152 SymbolicName=NET2152
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This printer is not used by a printer queue.

ACTION

Check the spelling of the printer name and then retype the command.

.
MessageId=2153 SymbolicName=NET2153
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This printer has already been installed.

ACTION

Be sure you typed the correct device name.

.
MessageId=2154 SymbolicName=NET2154
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You tried to create a printer queue with a name that is
already in use on this server.

ACTION

Give the new queue a different name. To see a list of printer queues already existing on the server, type:

	NET PRINT

.
MessageId=2155 SymbolicName=NET2155
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server does not have enough memory available to add another printer queue.

ACTION

To free memory, delete an existing printer queue. Then create and share the new queue.

You can also reconfigure the server to allow more printer queues by increasing
the value of the MAXQUEUES entry in the server's configuration file. 
This entry defines the maximum number of queues the server can share. 
After you edit the configuration file, stop and start the server's spooler for the changes to take effect.

.
MessageId=2156 SymbolicName=NET2156
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server does not have enough memory available to add another print job.

ACTION

Wait a while, then send the print job again.

If the problem persists, you may want to contact your network administrator about changing the MAXJOBS entry
in the server's configuration file. This entry defines the maximum number of print jobs allowed on the server at one time.

If the configuration file is changed, you must stop and restart the server's spooler for the changes to take effect.

.
MessageId=2157 SymbolicName=NET2157
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server does not have enough memory available to add another printer.

ACTION

Change the MAXPRINTERS entry in the server's configuration file. This entry defines the maximum number of printers the server can share. Then stop and restart the spooler for the changes to take effect.

.
MessageId=2158 SymbolicName=NET2158
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The specified printer is not in use.

ACTION

Be sure you are referring to the correct printer.

.
MessageId=2159 SymbolicName=NET2159
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An internal control function is invalid.

ACTION

Contact technical support.

.
MessageId=2160 SymbolicName=NET2160
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The spooler is failing to communicate with the print
processor.

ACTION

See your network administrator. There may be software
problems with the print processor or hardware problems with
the associated printer.

.
MessageId=2161 SymbolicName=NET2161
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The spooler has not been started.

ACTION

Use the Print Manager to start the spooler.

.
MessageId=2162 SymbolicName=NET2162
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The requested change cannot be made because a software error occurred.

ACTION

Contact technical support.

.
MessageId=2163 SymbolicName=NET2163
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The requested change cannot be made because a software error occurred.

ACTION

Contact technical support.

.
MessageId=2164 SymbolicName=NET2164
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The requested change cannot be made because a software error occurred.

ACTION

Contact technical support.

.
MessageId=2165 SymbolicName=NET2165
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The spooler ran out of memory.

ACTION

To free memory for the spooler, delete one or more printer queues or print jobs, or remove one or more printers from all print queues on the server.

.
MessageId=2166 SymbolicName=NET2166
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The device driver you specified has not been installed for the printer queue.

ACTION

Check the spelling of the name of the device driver.

To use a new device driver with this printer queue, you must first use Control Panel to install the device driver. For more information about Control Panel, see your operating system manual(s).

.
MessageId=2167 SymbolicName=NET2167
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The data type of the print job is not supported by the queue's print processor.

ACTION

Use a different print processor for jobs that have this data type, or rewrite the application so that it uses a data type the print processor can recognize.

.
MessageId=2168 SymbolicName=NET2168
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The print processor you specified has not been installed on the server.

ACTION

Use Control Panel to install a print processor.
For more information about the Control Panel, see your operating system manual(s).

.
MessageId=2180 SymbolicName=NET2180
Language=English
EXPLANATION

Another program is holding the service database lock.

ACTION

Wait for the lock to be released and try again later.  If it is possible to determine which program is holding the lock, then end that program.

.
MessageId=2181 SymbolicName=NET2181
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot start another service because you have reached the maximum number of services specified in your configuration file.

ACTION

You can start another service if you first stop a nonessential one. To display the list of services that are running, type:

	NET START

You could also change the maximum number of services allowed to run simultaneously on the computer by changing the value of the NUMSERVICES entry in the computer's configuration file. If you need assistance, contact your network administrator.

.
MessageId=2182 SymbolicName=NET2182
Language=English
EXPLANATION

You tried to start a service that is already running.

ACTION

To display a list of active services, type:

	NET START

.
MessageId=2183 SymbolicName=NET2183
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2184 SymbolicName=NET2184
Language=English
EXPLANATION

You tried to use a service that is not running.

ACTION

To display a list of active services, type:

	NET START

To start a service, type:

	NET START service

.
MessageId=2185 SymbolicName=NET2185
Language=English
EXPLANATION

You tried to start a service that is not configured on this system.

ACTION

Check the spelling of the service name or check the configuration information for the service using the Services option from Server Manager.

.
MessageId=2186 SymbolicName=NET2186
Language=English
EXPLANATION

The service cannot run your command at this time.

ACTION

Try the command again later.

If the problem persists, stop and restart the service.

However, if the problem continues after you have restarted the service, report the problem. Be sure to include the name of the service and the command that was refused, to technical support.

.
MessageId=2187 SymbolicName=NET2187
Language=English
EXPLANATION

The service is not responding to requests now. Another program may be controlling the service or there may be a software problem.

ACTION

Try to stop the service by typing:

     NET STOP service

If this fails, stop all programs running on the computer
and try typing the NET STOP command again.

If the problem persists, contact technical support.
Be prepared to give the name of the service and other information about the system, such as the services and applications that were running on the computer, and the amount and type of network activity when the problem occurred.

.
MessageId=2188 SymbolicName=NET2188
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Your configuration file has associated a service with a nonexistent program file.

ACTION

Be sure that each entry shown in the [services]
section of your configuration file lists a valid pathname
for the service's executable file. If you need assistance, contact  your network administrator.

.
MessageId=2189 SymbolicName=NET2189
Language=English
EXPLANATION

The service is not currently accepting requests. If
the service is starting, it cannot process requests until it is fully started.

ACTION

Try the operation again in a minute or two.

If this problem persists, the service may be stuck in a partially running state. Contact technical support. Be prepared to give the name of the service and other information about the system, such as the services and applications that were running, and the type and amount of network activity on the computer at the time of the problem.

.
MessageId=2190 SymbolicName=NET2190
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The service was not running properly and would not respond to a command. The service was terminated.

ACTION

Stop the service by typing:

     NET STOP service

Then restart the service by typing:

     NET START service

If the problem occurs frequently, contact technical support.

.
MessageId=2191 SymbolicName=NET2191
Language=English
EXPLANATION

This command is invalid for this service, or the service cannot accept the command right now.

ACTION

If the service normally accepts this command, try typing it
again later.

To display a list of valid commands, type:

	NET HELP

.
MessageId=2200 SymbolicName=NET2200
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A user is already logged on at this workstation.

ACTION

To see who is currently logged on at the workstation, type:

	NET CONFIG WORKSTATION

.
MessageId=2202 SymbolicName=NET2202
Language=English
EXPLANATION

You specified an invalid user name or group name.

ACTION

Use a different user name or group name.

.
MessageId=2203 SymbolicName=NET2203
Language=English
EXPLANATION

You specified an invalid password.

ACTION

Use a valid password.

.
MessageId=2204 SymbolicName=NET2204
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Your user name was not added as a new message alias for one of the following reasons:

- The Messenger service is not started on your workstation.

- Your user name and your workstation's computer name are the
  same, and your workstation's computer name is already a
  message alias.

- Your user name is in use as a message alias on another
  computer on the network. In this case, you cannot
  receive messages at the local workstation using this name.

ACTION

Start the Messenger service on your workstation if it is not already started. Then use the NET NAME command to add your user name as a message alias.

If your user name is being used as a message alias on another computer, delete the alias on that computer. Then use the NET NAME command to add your user name as a message alias on this computer.

.
MessageId=2205 SymbolicName=NET2205
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Your user name is already established as a message
alias. Either your user name and computer name are the same, or your user name is in use as a message alias on another computer on the network. 
If your user name is being used as a message alias on another computer, you cannot receive messages at the loca
l workstation using this name.

ACTION

If your user name is being used as a message alias on another computer, delete the alias on that computer. Then log on again at this computer.

.
MessageId=2206 SymbolicName=NET2206
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The message alias corresponding to your user name was not
deleted. Either your user name is the same as the computer name, or your user name is being used as a message alias on some other network computer.

ACTION

No action is needed.

.
MessageId=2207 SymbolicName=NET2207
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The message alias corresponding to your user name was not
deleted because your user name is the same as the computer name.

ACTION

No action is needed.

.
MessageId=2209 SymbolicName=NET2209
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
An administrator has paused the Netlogon service. No one can log on until the Netlogon service is continued.

ACTION

The administrator must continue the Netlogon service by typing:

     NET CONTINUE NETLOGON

.
MessageId=2210 SymbolicName=NET2210
Language=English
EXPLANATION

You can't start the Netlogon service on this server because a server in the domain with an earlier version the software is running the Netlogon service.

ACTION

Before you can start the Netlogon service on this server, you must stop the Netlogon service on all servers in the domain running earlier versions of the software.


.
MessageId=2212 SymbolicName=NET2212
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The logon script for your account may contain unrecognized commands or commands that could not run.

ACTION

Ask your network administrator to review your logon script.

.
MessageId=2214 SymbolicName=NET2214
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The logon was not validated by a logon server.

ACTION

No action is needed.

.
MessageId=2215 SymbolicName=NET2215
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
No domain controller is responding to your command.

ACTION

See your network administrator.

.
MessageId=2216 SymbolicName=NET2216
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This workstation already has a logon domain established.

ACTION

To log on in a different domain, you must first log off from the current domain and then log on again to a different domain.

.
MessageId=2217 SymbolicName=NET2217
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Your logon server is running an earlier version of LAN Manager.

ACTION

No action is needed.

.
MessageId=2219 SymbolicName=NET2219
Language=English
EXPLANATION

Windows NT could not find the security database file. 

ACTION

Copy the backup version of the file.


.
MessageId=2220 SymbolicName=NET2220
Language=English
EXPLANATION

You specified an unknown group name.

ACTION

Check the spelling of the group name. To display a list of the groups in the security database, type:

	NET GROUP

.
MessageId=2221 SymbolicName=NET2221
Language=English
EXPLANATION

You specified an unknown user name.

ACTION

Check the spelling of the user name. To display
a list of the users in the security database, type:

	NET USER

.
MessageId=2222 SymbolicName=NET2222
Language=English
EXPLANATION

You tried to access the permissions for a resource that has no permissions assigned to it.

ACTION

Check the spelling of the resource's name.

Before you can assign user permissions for a particular resource, you must create a record of that resource in the database of resource permissions.


.
MessageId=2223 SymbolicName=NET2223
Language=English
EXPLANATION

You tried to create a group with a group name that already exists.

ACTION

Use a different group name for the new group. To display
a list of group names established on the server, type:

	NET GROUP

.
MessageId=2224 SymbolicName=NET2224
Language=English
EXPLANATION

You tried to create a user account with a user name that already exists.

ACTION

Use a different user name for the new user account.
To display a list of existing user names, type:

	NET USER

.
MessageId=2225 SymbolicName=NET2225
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You tried to create an access record for a resource that already has one.

ACTION

To view or change permissions for this resource, use the Permissions editor from the File Manager.

.
MessageId=2226 SymbolicName=NET2226
Language=English
EXPLANATION

The specified server is not the domain controller, so you cannot update its security database.

ACTION

Run the command on the domain controller. If you are using User Manager, set the focus on the domain controller, and then retry the command.

.
MessageId=2227 SymbolicName=NET2227
Language=English
EXPLANATION

The security database is not active. This database must be active for the command to run.

ACTION

The security database should have started when the Workstation service started. Check the error log with Event Viewer to determine why the database did not start.

.
MessageId=2228 SymbolicName=NET2228
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The user accounts database is full.

ACTION

Make space in the database by deleting users, groups, and resource permissions.

.
MessageId=2229 SymbolicName=NET2229
Language=English
EXPLANATION

A software error occurred while Windows NT tried to access a down-level security database file.

ACTION

Type the command again. If the error persists, use a backup copy of the security database from a server and try the command again.  If the error persists, your disk drive may have hardware problems.

.
MessageId=2230 SymbolicName=NET2230
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Each resource can have no more than 64 access records defined.

ACTION

Put the users into groups and specify permissions for the groups, rather than for each user.

.
MessageId=2231 SymbolicName=NET2231
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The user currently has a session with the server.

ACTION

The session must be ended before you can delete a user.

.
MessageId=2232 SymbolicName=NET2232
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
No permissions have been assigned for the parent directory.

ACTION

Your network administrator must assign permissions for this resource.

.
MessageId=2233 SymbolicName=NET2233
Language=English
EXPLANATION

The security database has reached its size limit. Nothing can be added to it.

ACTION

No action is needed.

.
MessageId=2234 SymbolicName=NET2234
Language=English
EXPLANATION

You cannot perform this task on special groups such as Users, Administrators and Guests.

ACTION

No action is needed.

.
MessageId=2235 SymbolicName=NET2235
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2236 SymbolicName=NET2236
Language=English
EXPLANATION

The user you are trying to add to this group is already
a member.

ACTION

No action is needed.

.
MessageId=2237 SymbolicName=NET2237
Language=English
EXPLANATION

This user is not a member of this group.

ACTION

To see a list of users in this group, type:

     NET GROUP groupname

.
MessageId=2238 SymbolicName=NET2238
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2239 SymbolicName=NET2239
Language=English
EXPLANATION

Only an administrator can access an expired account.

ACTION

The administrator must reinstate this account before the action you specified can be taken.

.
MessageId=2240 SymbolicName=NET2240
Language=English
EXPLANATION

You are not allowed to log on from this workstation.

ACTION

If you need to log on from this workstation, have your network administrator change the logon workstation(s) listed in your account.

.
MessageId=2241 SymbolicName=NET2241
Language=English
EXPLANATION

You are not allowed to log on at this time of day.

ACTION

If you need to log on, have your network administrator change the logon hours listed in your account.

.
MessageId=2242 SymbolicName=NET2242
Language=English
EXPLANATION

Your password has expired. You will not be able to perform any network tasks until you change your password.

ACTION

To change your password, press Ctrl+Alt+Del and then select Change Password.

.
MessageId=2243 SymbolicName=NET2243
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot change your password.

ACTION

See your network administrator if you want your password changed.

.
MessageId=2244 SymbolicName=NET2244
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot use a password that has just expired. Your network administrator may also have configured your account so that you cannot use any of your previous passwords.

ACTION

Change your password to one that you have not used before.

.
MessageId=2245 SymbolicName=NET2245
Language=English
EXPLANATION

The password you specified is not long enough.

ACTION

Use a longer password. See your network administrator to find the required length for passwords on your system.


.
MessageId=2246 SymbolicName=NET2246
Language=English
EXPLANATION

You cannot change your password again for a certain length of time.

ACTION

No action is needed. See your network administrator to find the length of time that you must use your current password.

.
MessageId=2247 SymbolicName=NET2247
Language=English
EXPLANATION

The security database is damaged.

ACTION

Restore the security database from a backup.


.
MessageId=2248 SymbolicName=NET2248
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A server requested an update of the user accounts database, even though no update was required.

ACTION

No action is needed.

.
MessageId=2249 SymbolicName=NET2249
Language=English
EXPLANATION

The local server's security database is completely out of synchronization with that of the domain controller, so a complete synchronization is needed.

ACTION

Use the Synchronize With Domain option in Server Manager to synchronize the local server's database with that of the domain controller.

.
MessageId=2250 SymbolicName=NET2250
Language=English
EXPLANATION

This network connection does not exist.

ACTION

To display a list of shared resources to which your computer
is connected, type:

	NET USE

.
MessageId=2251 SymbolicName=NET2251
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=2252 SymbolicName=NET2252
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The device name you have tried to assign to a shared resource represents a local device that is already being shared.

ACTION

Select another device name or stop sharing the device you specified.

.
MessageId=2270 SymbolicName=NET2270
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=2271 SymbolicName=NET2271
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You tried to start the Messenger service, but it is already running.

ACTION

No action is needed. If this error occurs often, contact technical support.

.
MessageId=2272 SymbolicName=NET2272
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The initialization sequence of the Messenger service failed,
so the service could not start.

ACTION

Check the error log for error messages related to the
Messenger service failing to start. This problem may be
caused by the way your workstation or server is configured,
or by hardware or software errors.

.
MessageId=2273 SymbolicName=NET2273
Language=English
EXPLANATION

This message alias could not be located.

ACTION

Check the spelling of the message alias. If it is correct, then the computer that is to receive your message may be busy. Try sending the message again later.

.
MessageId=2275 SymbolicName=NET2275
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Messages for this alias are being forwarded to another computer.

ACTION

Stop forwarding messages and allow messages to be
received by the local computer again.

.
MessageId=2276 SymbolicName=NET2276
Language=English
EXPLANATION

You tried to add a message alias that already exists on this computer.

ACTION

Use a different name if you want to add a new message alias.

To display the list of aliases on this computer, type

     NET NAME

.
MessageId=2277 SymbolicName=NET2277
Language=English
EXPLANATION

The maximum number of message aliases on each computer is
limited by the system hardware. You have reached this limit.

This limit also affects the number of other domains you can specify with the OTHDOMAINS option of the NET CONFIG WORKSTATION command.

ACTION

To find the limit for your system, see your hardware documentation or ask your administrator.

To display a list of current message aliases, type:

	NET NAME

To delete a message alias to make room for a new message alias or another domain specified by the OTHDOMAINS option, type:

	NET NAME alias /DELETE

.
MessageId=2278 SymbolicName=NET2278
Language=English
EXPLANATION

You cannot delete a message alias that is also a computer name.

ACTION

No action is needed.

.
MessageId=2279 SymbolicName=NET2279
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot forward a message to yourself at your own
workstation.

ACTION

No action is needed.

.
MessageId=2280 SymbolicName=NET2280
Language=English
EXPLANATION

An error occurred when the workstation was receiving or processing a domain-wide message.

ACTION

Check the workstation's Event log, by selecting System from the Log menu using Event Viewer. Stop and restart the Messenger service.

If the problem persists, contact technical support.

.
MessageId=2281 SymbolicName=NET2281
Language=English
EXPLANATION

The person receiving your message has paused the Messenger service, so your message could not be received.

ACTION

Send your message again later. If the error persists, see your network administrator.

.
MessageId=2282 SymbolicName=NET2282
Language=English
EXPLANATION

The remote workstation was unable to receive your message. The Workstation or Messenger service may not be running on that workstation, it may have been receiving another message as yours arrived, or its message buffer may be too small.

ACTION

Send your message again later. If the error persists, see your network administrator.

.
MessageId=2283 SymbolicName=NET2283
Language=English
EXPLANATION

The computer to which you tried to send a message was receiving another message. A computer can receive only one message at a time.

ACTION

Send the message again later.

.
MessageId=2284 SymbolicName=NET2284
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Messenger service must be running for you to use this command.

ACTION

To start the Messenger service, type:

	NET START MESSENGER

.
MessageId=2285 SymbolicName=NET2285
Language=English
EXPLANATION

You tried to delete a message alias that is not on
your computer.

ACTION

To display a list of aliases on your computer and to check the spelling of the aliases, type:

	NET NAME

.
MessageId=2286 SymbolicName=NET2286
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This alias no longer exists on the workstation that was receiving the alias's forwarded messages. The alias may have been deleted at that workstation, or the workstation may have been restarted.

ACTION

Restart the workstation or add the alias to the workstation again.

.
MessageId=2287 SymbolicName=NET2287
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The workstation to which you are trying to forward the
message alias has no room for new aliases.

ACTION

Ask the user on that workstation if an existing alias can be deleted so yours can be added, or forward your alias to a different workstation.

.
MessageId=2288 SymbolicName=NET2288
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Messages for this alias are not being forwarded.

ACTION

No action is needed.

.
MessageId=2289 SymbolicName=NET2289
Language=English
EXPLANATION

The broadcast message was too long. Only the first 128 characters of the message were sent.

ACTION

Keep broadcast messages to 128 characters or less.

.
MessageId=2294 SymbolicName=NET2294
Language=English
EXPLANATION

You typed a command or ran a program that specified an invalid device name.

ACTION

If you specified the device name, be sure that it is valid and that you have typed it correctly.

If a program specified the device name, consult the
program's documentation.

.
MessageId=2295 SymbolicName=NET2295
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager found an error when writing to the message log file.

ACTION

Contact your network administrator.

.
MessageId=2297 SymbolicName=NET2297
Language=English
EXPLANATION

The name you specified is already in use as a message alias on the network.

ACTION

Use a different name.

.
MessageId=2298 SymbolicName=NET2298
Language=English
EXPLANATION

Some hardware configurations have a delay between the typing of a command and the deletion of an alias.

ACTION

No action is needed. The deletion will occur soon.

.
MessageId=2299 SymbolicName=NET2299
Language=English
EXPLANATION

The message alias could not be deleted from all networks of which this computer is a member. This should cause no problems.

ACTION

If this error occurs frequently, contact technical support.

.
MessageId=2300 SymbolicName=NET2300
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot run this command on a computer that is on multiple networks.

ACTION

No action is needed.

.
MessageId=2310 SymbolicName=NET2310
Language=English
EXPLANATION

The share name you specified does not exist.

ACTION

Check the spelling of the share name.

To display a list of resources shared on the server, type:

     NET SHARE

.
MessageId=2311 SymbolicName=NET2311
Language=English
EXPLANATION

The device you specified is not shared.

ACTION

Check the spelling of the device name.

To share the device, type:

	NET SHARE sharename=devicename

.
MessageId=2312 SymbolicName=NET2312
Language=English
EXPLANATION

The specified computer does not have a session with the server.

ACTION

Check the spelling of the computer name.

To display a list of workstations and users that have sessions with the server, type:

	NET SESSION

.
MessageId=2314 SymbolicName=NET2314
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
There is no open file on the server corresponding to the number you specified.

ACTION

Check the identification number of the open file. To display a list of open files and their identification numbers, type:

	NET FILE

.
MessageId=2315 SymbolicName=NET2315
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The command cannot run on the remote server, probably
because of a problem with the server's operating system configuration.

ACTION

Have your network administrator check the configuration of the server's operating system.

.
MessageId=2316 SymbolicName=NET2316
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The command could not be completed because it could not open a temporary file on the server.

ACTION

See your network administrator. If you need further help, contact technical support.

.
MessageId=2317 SymbolicName=NET2317
Language=English
.
MessageId=2318 SymbolicName=NET2318
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot route requests from both a printer queue and a communication-device queue to the same device.

ACTION

To assign the device to a printer queue, you must first remove it from all communication-device queues.

To assign the device to a communication-device queue, you must remove it from all printer queues.

.
MessageId=2319 SymbolicName=NET2319
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2320 SymbolicName=NET2320
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Your computer is not active in the domain you specified.

ACTION

To perform tasks in the specified domain, you must add the domain to the list of domains in which the workstation is a member.

.
MessageId=2331 SymbolicName=NET2331
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The command cannot be used on a communication-device queue.

ACTION

If you need further help, contact your network administrator.

.
MessageId=2332 SymbolicName=NET2332
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The device name you typed does not represent a valid local device that can be shared.

ACTION

Select a valid device name.

.
MessageId=2333 SymbolicName=NET2333
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You tried to purge an empty communication-device queue.

ACTION

No action is needed.

.
MessageId=2334 SymbolicName=NET2334
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.


.
MessageId=2335 SymbolicName=NET2335
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2337 SymbolicName=NET2337
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server is not sharing any communication-device queues, so the command you typed is invalid.

ACTION

No action is needed.

.
MessageId=2338 SymbolicName=NET2338
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The queue name you typed does not exist.

ACTION

Check the spelling of the queue name.

.
MessageId=2340 SymbolicName=NET2340
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2341 SymbolicName=NET2341
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The device name is invalid because it does not represent a physical device or because the device hardware is faulty.

ACTION

Check the spelling of the device name, and then retype the command.

If the problem persists, contact your network administrator.
Your administrator should use diagnostics to check that the device hardware is properly installed and working.

For more assistance, contact your hardware dealer.

.
MessageId=2342 SymbolicName=NET2342
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This device is used with a printer queue. You cannot use a device with both printer queues and communication-device queues.

ACTION

To use this device with a communication-device queue, you must first disconnect all printer queues from it.

.
MessageId=2343 SymbolicName=NET2343
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This device is used with a communication-device queue.
You cannot use a device with both communication-device queues and printer queues.

ACTION

To use this device with a printer queue, you must
disconnect all communication-device queues from it.

.
MessageId=2351 SymbolicName=NET2351
Language=English
EXPLANATION

The specified computer name is invalid.

ACTION

Contact technical support.


.
MessageId=2354 SymbolicName=NET2354
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.


.
MessageId=2356 SymbolicName=NET2356
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2357 SymbolicName=NET2357
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=2362 SymbolicName=NET2362
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=2370 SymbolicName=NET2370
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The profile is too large. Profile files can be no larger than 64 kilobytes.

ACTION

Remove unnecessary commands from the profile and try loading it again.

.
MessageId=2371 SymbolicName=NET2371
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2372 SymbolicName=NET2372
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
Loading the profile failed because one or more connections between your computer and other network computers are active. LAN Manager could not delete the active connections.

ACTION

If you were trying to load the profile onto a workstation, be sure the workstation is not actively using any shared resources. Be sure the current directory in each session is not a shared directory.

If you were trying to load the profile onto a server, you must wait until none of the server's shared resources are being actively used. To see which users are actively using the server's resources, type:

     NET FILE

.
MessageId=2373 SymbolicName=NET2373
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The profile contains an invalid command.

ACTION

Check the profile. See your network administrator if you need assistance.

.
MessageId=2374 SymbolicName=NET2374
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The system could not open the profile.

ACTION

The profile file may be damaged. Create a new profile. If you need assistance, contact your network administrator.

.
MessageId=2375 SymbolicName=NET2375
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You are logged on with an account that does not have sufficient privilege to save the server's entire current configuration. Only part of the configuration was saved to the profile.

ACTION

Log on with an account that has administrative privilege (or server operator privilege) before saving a server profile.


.
MessageId=2377 SymbolicName=NET2377
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The log file is too large.

ACTION

Clear the log file or increase the MAXERRORLOG entry in the computer's configuration file. If you need assistance, contact your network administrator.

.
MessageId=2378 SymbolicName=NET2378
Language=English
EXPLANATION

You cannot begin reading the log file from the previously established position because the log file has changed since the last time you read it.

ACTION

Read the log file from the beginning.

.
MessageId=2379 SymbolicName=NET2379
Language=English
.
MessageId=2380 SymbolicName=NET2380
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The source path you typed is a directory name, which is not
allowed.

ACTION

You must include a filename or wildcard in the path.

To copy all files in a directory, type:

	COPY [source]\*.* destination

.
MessageId=2381 SymbolicName=NET2381
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You referred to a nonexistent drive, directory, or
filename, or you typed the command incorrectly.

ACTION

Check the spelling of the source or pathname you have typed.
Remember to precede computer names with two backslashes, as in \\computername.

.
MessageId=2382 SymbolicName=NET2382
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The destination path does not exist.

ACTION

Check the spelling of the destination path. If you need more information, see your network administrator.

.
MessageId=2383 SymbolicName=NET2383
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2385 SymbolicName=NET2385
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You tried to run a program or command on a server that is paused.

ACTION

See your network administrator. The administrator must continue the server for your command to run.

.
MessageId=2389 SymbolicName=NET2389
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager found a problem while trying to complete the task.

ACTION

Type the command again in a few minutes. If you continue to receive this message, see your network administrator.

.
MessageId=2391 SymbolicName=NET2391
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager found a problem while trying to complete the task.

ACTION

Type the command again in a few minutes. If you continue to receive this message, see your network administrator.

.
MessageId=2392 SymbolicName=NET2392
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager found a problem while trying to complete the task.

ACTION

Type the command again in a few minutes. If you continue to receive this message, see your network administrator.

.
MessageId=2400 SymbolicName=NET2400
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The LAN adapter number in the configuration file is incorrect.

ACTION

A NETn entry in the [networks] section of the computer's configuration file needs to be corrected. See your network administrator if you need assistance.

.
MessageId=2401 SymbolicName=NET2401
Language=English
EXPLANATION

You tried to delete an active connection. There
are open files or requests pending on this connection.

ACTION

Close all files and end all programs related to the connection before you try to delete it.

.
MessageId=2402 SymbolicName=NET2402
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You tried to delete a network connection that has an active process, or you tried to log off while you have an active process.

ACTION

Be sure that the processes running on a server are completed before you break the connection to that server, and that processes on all remote servers are completed before you log off.

.
MessageId=2403 SymbolicName=NET2403
Language=English
EXPLANATION

Either the share name or password you typed is incorrect.

ACTION

Check the spelling of the share name or password. If you still have problems, ask your network administrator to verify the password and the share name. Your administrator should also verify that you have access to the resource.

This problem can also be caused by duplicate computer names. Do not give computers on different networks identical computer names if there is any computer that is on both networks.

.
MessageId=2404 SymbolicName=NET2404
Language=English
EXPLANATION

The drive letter you specified is the current drive of a session. You tried to delete a drive redirection (x:) while it is in use, possibly as your current drive.

ACTION

Be sure the drive you are trying to delete is not the current drive in any of your sessions.

.
MessageId=2405 SymbolicName=NET2405
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You tried to assign a local drive letter to a shared resource.

ACTION

Use a drive letter that does not correspond to a local drive.

.
MessageId=2430 SymbolicName=NET2430
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A program requested the alerter notify it of an event for which it is already receiving notifications.

ACTION

Contact technical support.

.
MessageId=2431 SymbolicName=NET2431
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The number of alert notifications requested exceeded the
number specified by the NUMALERTS entry in your configuration
file.

ACTION

Increase the value of the NUMALERTS entry. Then stop and
restart the Workstation service.

.
MessageId=2432 SymbolicName=NET2432
Language=English
EXPLANATION

A software error occurred.

ACTION

Be sure the Alerter service is started.

If this error occurs while the Alerter service is started, contact technical support.

.
MessageId=2433 SymbolicName=NET2433
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.

.
MessageId=2434 SymbolicName=NET2434
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
LAN Manager ended a user's session with this server because the user's logon time expired.

ACTION

No action is needed.

To define the times during which a user can access the server, type:

     NET USER username /TIMES:times

.
MessageId=2440 SymbolicName=NET2440
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

Contact technical support.


.
MessageId=2450 SymbolicName=NET2450
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The user accounts database is not configured properly. There may be a conflict between the computer's role, which defines how this server participates in logon security, and the server's record of the name of the primary domain controller.

For example, the role of this computer may be set to PRIMARY while the primary domain controller entry names a different server.

ACTION

Contact your network administrator.

.
MessageId=2451 SymbolicName=NET2451
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
You cannot perform this task while the Netlogon service is running.

ACTION

To perform this task, stop the Netlogon service on the server. Retype the command, and then restart the Netlogon service.

.
MessageId=2452 SymbolicName=NET2452
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This is the only account with administrative privilege. You cannot delete it.

ACTION

You must add another account with administrative privilege before
deleting this one.


.
MessageId=2453 SymbolicName=NET2453
Language=English
EXPLANATION

Windows NT could not find the domain controller for this domain. This task cannot be completed unless the domain controller is running in this domain.

ACTION

Start the Netlogon service on the domain controller.

.
MessageId=2454 SymbolicName=NET2454
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The logon server could not update the logon or logoff information.

ACTION

Stop and restart the Netlogon service at the server that returned this error.


.
MessageId=2455 SymbolicName=NET2455
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The Netlogon service is not running.

ACTION

Start the Netlogon service at the server, and then type the command again.

.
MessageId=2456 SymbolicName=NET2456
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The user accounts database cannot be enlarged because the server's hard disk is full.

ACTION

Check the server's disk and remove unnecessary and outdated files.

.
MessageId=2460 SymbolicName=NET2460
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

If this error persists or causes other errors, contact technical support.

.
MessageId=2461 SymbolicName=NET2461
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

If this error persists or causes other errors, contact technical support.

.
MessageId=2462 SymbolicName=NET2462
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
A software error occurred.

ACTION

If this error persists or causes other errors, contact technical support.

.
MessageId=2463 SymbolicName=NET2463
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The table of available servers is full. You will not be able to see a complete list of network servers when you type the NET VIEW command or use the LAN Manager Screen.

ACTION

Stopping other processes or services on the workstation may free enough memory to correct this problem.

MS-DOS workstations have a NUMSERVERS entry in the configuration file, which specifies the number of servers that the workstation can list with NET VIEW. Increasing this value can solve this problem, but will also use more memory.

.
MessageId=2464 SymbolicName=NET2464
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server is supporting the maximum number of sessions.

ACTION

Try the command later. You will not be able to start a session with this server until another user's session has ended.

Also, see your network administrator. Your administrator may want to purchase an Additional User Pak for the server or increase the value of the MAXUSERS entry of the server's configuration file.

.
MessageId=2465 SymbolicName=NET2465
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The server is supporting the maximum number of connections.

ACTION

To make another connection to the server, first end a current connection.

If you have no connections that you can end, try your command again later. You will be able to make your connection once another user's connection is ended.

Also, see your network administrator. The administrator may want to increase the value of the MAXCONNECTIONS entry of the server's configuration file.

.
MessageId=2466 SymbolicName=NET2466
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
No more files on the server can be opened.

ACTION

To open another file, you will first have to close a file or stop a network application that has open files.

Also, see your network administrator. Your administrator may want to increase the value of the MAXOPENS entry in the server's configuration file.

.
MessageId=2467 SymbolicName=NET2467
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
This server has no alternate servers registered.

ACTION

Contact your network administrator.

.
MessageId=2480 SymbolicName=NET2480
Language=English
EXPLANATION

This message should occur only on a down-level computer. Any action to correct the problem should be performed on that computer.
The UPS service could not access the UPS driver (UPSDRV.OS2). The UPS driver might not be configured properly.

ACTION

Be sure that your CONFIG.SYS file has a DEVICE line specifying the location of the UPS device driver and that the /PORT option of that line specifies the serial port that the UPS is connected to. This line must appear before any other lines that inst


all o
ther serial port drivers.

If you make changes to CONFIG.SYS, you will need to reboot your system for them to take effect.
.
MessageId=3051 SymbolicName=NET3051
Language=English
EXPLANATION

You specified invalid values for one or more of the service's options.

ACTION

Retype the command with correct values, or change the values for the listed options in the configuration file.

.
MessageId=3052 SymbolicName=NET3052
Language=English
EXPLANATION

This message should occur only on a down level computer. Any action to correct the problem should be performed on that computer.
You must specify a value for the listed option.

ACTION

Define a value for the option, either from the command line or in the configuration file.

.
MessageId=3053 SymbolicName=NET3053
Language=English
EXPLANATION

This message should occur only on a down level computer. Any action to correct the problem should be performed on that computer.
This option is not valid for this service.

ACTION

Check the spelling of this option. If you did not type it from the command line, check the configuration file.

.
MessageId=3054 SymbolicName=NET3054
Language=English
EXPLANATION

The service required more of the listed resource than was
available.

ACTION

Increase the amount of this resource. Stopping other services or applications may free some resources, such as memory.

Also check the disk where your pagefile(s) are located. If this disk is full, delete unnecessary files and directories from it to clear space.

.
MessageId=3055 SymbolicName=NET3055
Language=English
EXPLANATION

This message should occur only on a down level computer. Any action to correct the problem should be performed on that computer.
The system is not configured correctly.

ACTION

Contact your network administrator.

.
MessageId=3056 SymbolicName=NET3056
Language=English
EXPLANATION

The system error may be an internal LAN Manager or Windows NT error.

ACTION

If the error code is Error 52, you need to delete the duplicate domain name in 
the [othodomains] section of your configuration file. If an error code 
beginning with "NET" is displayed, you can use the HELPMSG command to see 
more information about the error as follows:
          NET HELPMSG message#

where message# is the actual error number.

If no error number was displayed, contact technical support.

.
MessageId=3057 SymbolicName=NET3057
Language=English
EXPLANATION

A software error occurred.

ACTION

Contact technical support.

.
MessageId=3058 SymbolicName=NET3058
Language=English
EXPLANATION

This message should occur only on a down level computer. Any action to correct the problem should be performed on that computer.
Some options can be confused with other options that start with the same letter.

ACTION

Spell out enough of the option so that it cannot be confused with other command options.

.
MessageId=3059 SymbolicName=NET3059
Language=English
EXPLANATION

This message should occur only on a down level computer. Any action to correct the problem should be performed on that computer.
An option was used more than once in your command or in the configuration file. An option can be used only once in a command and once in the configuration file. If an option is typed from the command line, 
it overrides the value in the configuration file. 

ACTION

Do not type the same option twice in a command. Be sure not to use different abbreviations that can specify the same option, such as "wrkserv" and "wrkservices."

If the error was not caused by a command, check the configuration file for duplicate options.

.
MessageId=3060 SymbolicName=NET3060
Language=English
EXPLANATION

The service did not respond to a control signal. The
service may not be running correctly or a fatal error might have occurred. Windows NT stopped the service.

ACTION

Contact technical support.

.
MessageId=3061 SymbolicName=NET3061
Language=English
EXPLANATION

The service you specified could not start.

ACTION

In the [services] section of your configuration file, find the name of the program file for this service. Be sure this file exists and is an executable file with a filename extension of .EXE or .COM.

If the program file exists, it may be damaged. If possible, restore the file from a backup version. Otherwise, contact technical support.

.
MessageId=3062 SymbolicName=NET3062
Language=English
EXPLANATION

The specified service could not be started automatically when another service was started.

ACTION

Start the service individually.

.
MessageId=3063 SymbolicName=NET3063
Language=English
EXPLANATION

This message should occur only on a down level computer. Any action to correct the problem should be performed on that computer.
Two command-line options or configuration file entries have conflicting values.

ACTION

Check the command you typed or the configuration file for conflicting options.

.
MessageId=3064 SymbolicName=NET3064
Language=English


















                                 *
.
