/*++

Copyright (c) 1992  Microsoft Corporation

Module Name:

    lmatmsg.h

Abstract:

    Definitions for AT command private errors.

Author:

    Vladimir Z. Vulovic     (vladimv)       06 - November - 1992

Revision History:

    06-Nov-1992     vladimv
        Created
    20-Feb-1993     yihsins
        Move hard-coded strings from atcmd.c to here.

Notes:

    This file is generated by the MC tool from the lmatmsg.mc file.


    In lanman2.1 and before, messages for AT utility used to be defined in
    common\h\apperr2.h.  In NT windows, error codes belonging to AT utility
    have been reused by redir statistics.  Therefore, we have to invent a
    whole new message file for these lost messages!

    Note that %1 was removed from messages for APE2_AT_EACH & APE2_AT_NEXT.

--*/
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: APE2_AT_DEL_WARNING
//
// MessageText:
//
//  This operation will delete all scheduled jobs.
//
#define APE2_AT_DEL_WARNING              0x00001216L

//
// MessageId: APE2_AT_SCHED_FILE_CLEARED
//
// MessageText:
//
//  The AT schedule file was cleared. 
//
#define APE2_AT_SCHED_FILE_CLEARED       0x00001217L

//
// MessageId: APE2_AT_TODAY
//
// MessageText:
//
//  Today %0
//
#define APE2_AT_TODAY                    0x00001218L

//
// MessageId: APE2_AT_TOMORROW
//
// MessageText:
//
//  Tomorrow %0
//
#define APE2_AT_TOMORROW                 0x00001219L

//
// MessageId: APE2_AT_NEXT
//
// MessageText:
//
//  Next %0
//
#define APE2_AT_NEXT                     0x0000121AL

//
// MessageId: APE2_AT_EACH
//
// MessageText:
//
//  Each %0
//
#define APE2_AT_EACH                     0x0000121BL

//   ++++++++++++++++++++++++++++ WARNING ++++++++++++++++++++++++++
//
//   The following messages up to APE2_AT_DI_INTERACTIVE are aligned to
//   look right when printed on the screen (they appear in a table).
//   If they are changed, make sure they occupy the same number of
//   chars (text+space). In the case of AT_DUMP_HEADER, the column 
//   headers should start at the same place (left justified).
//   
//   ---------------------------------------------------------------
//
// MessageId: APE2_AT_DUMP_HEADER
//
// MessageText:
//
//  Status ID   Day                     Time          Command Line
//
#define APE2_AT_DUMP_HEADER              0x0000121CL

//
// MessageId: APE2_AT_DI_TASK
//
// MessageText:
//
//  Task ID:       %0
//
#define APE2_AT_DI_TASK                  0x0000121DL

//
// MessageId: APE2_AT_DI_STATUS
//
// MessageText:
//
//  Status:        %0
//
#define APE2_AT_DI_STATUS                0x0000121EL

//
// MessageId: APE2_AT_DI_SCHEDULE
//
// MessageText:
//
//  Schedule:      %0
//
#define APE2_AT_DI_SCHEDULE              0x0000121FL

//
// MessageId: APE2_AT_DI_TIMEOFDAY
//
// MessageText:
//
//  Time of day:   %0
//
#define APE2_AT_DI_TIMEOFDAY             0x00001220L

//
// MessageId: APE2_AT_DI_COMMAND
//
// MessageText:
//
//  Command:       %0
//
#define APE2_AT_DI_COMMAND               0x00001221L

//
// MessageId: APE2_AT_DI_INTERACTIVE
//
// MessageText:
//
//  Interactive:   %0
//
#define APE2_AT_DI_INTERACTIVE           0x00001222L

//
// MessageId: IDS_LOAD_LIBRARY_FAILURE
//
// MessageText:
//
//  LoadLibrary() fails with winError = %1!d!
//
#define IDS_LOAD_LIBRARY_FAILURE         0x00002710L

//
// MessageId: IDS_UNABLE_TO_MAP_TO_UNICODE
//
// MessageText:
//
//  Failed to convert input strings to unicode strings.
//
#define IDS_UNABLE_TO_MAP_TO_UNICODE     0x00002711L

//
// MessageId: IDS_UNABLE_TO_MAKE_STRING_TO_UNICODE
//
// MessageText:
//
//  Failed to make unicode string out of %1.
//
#define IDS_UNABLE_TO_MAKE_STRING_TO_UNICODE 0x00002712L

//
// MessageId: IDS_ADD_NEW_JOB
//
// MessageText:
//
//  Added a new job with job ID = %1!d!
//
#define IDS_ADD_NEW_JOB                  0x00002713L

//
// MessageId: IDS_MESSAGE_GET_ERROR
//
// MessageText:
//
//  FormatMessage(%1!d!) fails with winError = %2!d!
//
#define IDS_MESSAGE_GET_ERROR            0x00002714L

//
// MessageId: IDS_MESSAGE_PRINT_ERROR
//
// MessageText:
//
//  FormatMessage(%1!d!) fails with winError = %2!d!
//
#define IDS_MESSAGE_PRINT_ERROR          0x00002715L

//
// MessageId: IDS_INVALID_COMMAND
//
// MessageText:
//
//  Invalid command.%n
//
#define IDS_INVALID_COMMAND              0x00002716L

//
// MessageId: IDS_YES
//
// MessageText:
//
//  YES%0
//
#define IDS_YES                          0x00002717L

//
// MessageId: IDS_DELETE
//
// MessageText:
//
//  DELETE%0
//
#define IDS_DELETE                       0x00002718L

//
// MessageId: IDS_EVERY
//
// MessageText:
//
//  EVERY%0
//
#define IDS_EVERY                        0x00002719L

//
// MessageId: IDS_NEXT
//
// MessageText:
//
//  NEXT%0
//
#define IDS_NEXT                         0x0000271AL

//
// MessageId: IDS_NO
//
// MessageText:
//
//  NO%0
//
#define IDS_NO                           0x0000271BL

//
// MessageId: IDS_USAGE
//
// MessageText:
//
//  The AT command schedules commands and programs to run on a computer at      
//  a specified time and date. The Schedule service must be running to use      
//  the AT command.%n                                                           
//  AT [\\computername] [ [id] [/DELETE] | /DELETE [/YES]]                    
//  AT [\\computername] time [/INTERACTIVE]
//      [ /EVERY:date[,...] | /NEXT:date[,...]] "command"%n
//  \\computername     Specifies a remote computer. Commands are scheduled on the
//                     local computer if this parameter is omitted.             
//  id                 Is an identification number assigned to a scheduled      
//                     command.                                                 
//  /delete            Cancels a scheduled command. If id is omitted, all the
//                     scheduled commands on the computer are canceled.
//  /yes               Used with cancel all jobs command when no further
//                     confirmation is desired.
//  time               Specifies the time when command is to run.
//  /interactive       Allows the job to interact with the desktop of the user   
//                     who is logged on at the time the job runs.
//  /every:date[,...]  Runs the command on each specified day(s) of the week or
//                     month. If date is omitted, the current day of the month
//                     is assumed.                                              
//  /next:date[,...]   Runs the specified command on the next occurrence of the
//                     day (for example, next Thursday).  If date is omitted, the
//                     current day of the month is assumed.
//  "command"          Is the Windows NT command, or batch program to be run.%n
//
#define IDS_USAGE                        0x0000271EL

//
// MessageId: IDS_INTERACTIVE
//
// MessageText:
//
//  INTERACTIVE%0
//
#define IDS_INTERACTIVE                  0x0000271FL

