/*++

Copyright (c) 1992  Microsoft Corporation

Module Name:

    rplmsg.h

Abstract:

    Definitions for Remoteboot command private errors.

Author:

    Vladimir Z. Vulovic     (vladimv)       06 - November - 1992

Revision History:
    Jon Newman     April - 28 - 1994
       moved & cleaned up bunch of messages


Notes:

    This file is generated by the MC tool from the rplmsg.mc file.


--*/
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: IDS_LOAD_LIBRARY_FAILURE
//
// MessageText:
//
//  LoadLibrary() fails with winError = %1!d!%n%0
//
#define IDS_LOAD_LIBRARY_FAILURE         0x00002710L

//
// MessageId: IDS_UNEXPECTED_RETURN_CODE
//
// MessageText:
//
//  Remote boot server returned an unexpected error = %1!d!%n%0
//
#define IDS_UNEXPECTED_RETURN_CODE       0x00002711L

//
// MessageId: IDS_OPEN_SERVICE_HANDLE
//
// MessageText:
//
//  Failed to open remote boot service handle.%n%0
//
#define IDS_OPEN_SERVICE_HANDLE          0x00002712L

//
// MessageId: IDS_CLOSE_SERVICE_HANDLE
//
// MessageText:
//
//  Failed to close remote boot service handle.%n%0
//
#define IDS_CLOSE_SERVICE_HANDLE         0x00002713L

//
// MessageId: IDS_PROMPT_ADAPTERCOMMENT
//
// MessageText:
//
//  AdapterComment=%0
//
#define IDS_PROMPT_ADAPTERCOMMENT        0x00002714L

//
// MessageId: IDS_PROMPT_ADAPTERNAME
//
// MessageText:
//
//  AdapterName=%0
//
#define IDS_PROMPT_ADAPTERNAME           0x00002715L

//
// MessageId: IDS_PROMPT_ADAPTERNAME_COMPATCONFIG
//
// MessageText:
//
//  To list only configurations compatible with a given network card, input AdapterName=%0
//
#define IDS_PROMPT_ADAPTERNAME_COMPATCONFIG 0x00002716L

//
// MessageId: IDS_PROMPT_ADAPTERNAME_COMPATPROF
//
// MessageText:
//
//  To list only profiles compatible with a given network card, input AdapterName=%0
//
#define IDS_PROMPT_ADAPTERNAME_COMPATPROF 0x00002717L

//
// MessageId: IDS_PROMPT_ADAPTERNAME_TARGET
//
// MessageText:
//
//  TargetAdapterName=%0
//
#define IDS_PROMPT_ADAPTERNAME_TARGET    0x00002718L

//
// MessageId: IDS_PROMPT_BOOTCOMMENT
//
// MessageText:
//
//  BootComment=%0
//
#define IDS_PROMPT_BOOTCOMMENT           0x00002719L

//
// MessageId: IDS_PROMPT_BOOTNAME
//
// MessageText:
//
//  BootName=%0
//
#define IDS_PROMPT_BOOTNAME              0x0000271AL

//
// MessageId: IDS_PROMPT_CONFIGCOMMENT
//
// MessageText:
//
//  ConfigComment=%0
//
#define IDS_PROMPT_CONFIGCOMMENT         0x0000271BL

//
// MessageId: IDS_PROMPT_CONFIGNAME
//
// MessageText:
//
//  ConfigName=%0
//
#define IDS_PROMPT_CONFIGNAME            0x0000271CL

//
// MessageId: IDS_PROMPT_DIRNAME
//
// MessageText:
//
//  DirName=%0
//
#define IDS_PROMPT_DIRNAME               0x0000271DL

//
// MessageId: IDS_PROMPT_DIRNAME2
//
// MessageText:
//
//  DirName2=%0
//
#define IDS_PROMPT_DIRNAME2              0x0000271EL

//
// MessageId: IDS_PROMPT_DIRNAME3
//
// MessageText:
//
//  DirName3=%0
//
#define IDS_PROMPT_DIRNAME3              0x0000271FL

//
// MessageId: IDS_PROMPT_DIRNAME4
//
// MessageText:
//
//  DirName4=%0
//
#define IDS_PROMPT_DIRNAME4              0x00002720L

//
// MessageId: IDS_PROMPT_FITFILE
//
// MessageText:
//
//  FitFile=%0
//
#define IDS_PROMPT_FITFILE               0x00002721L

//
// MessageId: IDS_PROMPT_FITPERSONAL
//
// MessageText:
//
//  FitPersonal=%0
//
#define IDS_PROMPT_FITPERSONAL           0x00002722L

//
// MessageId: IDS_PROMPT_FITSHARED
//
// MessageText:
//
//  FitShared=%0
//
#define IDS_PROMPT_FITSHARED             0x00002723L

//
// MessageId: IDS_PROMPT_LEVEL_DEBUG
//
// MessageText:
//
//  Information Level=%0
//
#define IDS_PROMPT_LEVEL_DEBUG           0x00002724L

//
// MessageId: IDS_PROMPT_LEVEL01
//
// MessageText:
//
//  Information Level (0 or 1)=%0
//
#define IDS_PROMPT_LEVEL01               0x00002725L

//
// MessageId: IDS_PROMPT_LEVEL012
//
// MessageText:
//
//  Information Level (0, 1 or 2)=%0
//
#define IDS_PROMPT_LEVEL012              0x00002726L

//
// MessageId: IDS_PROMPT_MENU_ADAPTER_ADE
//
// MessageText:
//
//  Add Del Enum: %0
//
#define IDS_PROMPT_MENU_ADAPTER_ADE      0x00002727L

//
// MessageId: IDS_PROMPT_FILTER_ADAPTER_ADE
//
// MessageText:
//
//  ADE%0
//
#define IDS_PROMPT_FILTER_ADAPTER_ADE    0x00002728L

//
// MessageId: IDS_PROMPT_MENU_ADAPTER_DE
//
// MessageText:
//
//  Del Enum: %0
//
#define IDS_PROMPT_MENU_ADAPTER_DE       0x00002729L

//
// MessageId: IDS_PROMPT_MENU_ADAPTERDELETEALL
//
// MessageText:
//
//  Are you sure you wish to delete all adapters? (Y/N)=%0
//
#define IDS_PROMPT_MENU_ADAPTERDELETEALL 0x0000272AL

//
// MessageId: IDS_PROMPT_MENU_BOOT_ADE
//
// MessageText:
//
//  Add Del Enum: %0
//
#define IDS_PROMPT_MENU_BOOT_ADE         0x0000272BL

//
// MessageId: IDS_PROMPT_FILTER_BOOT_ADE
//
// MessageText:
//
//  ADE%0
//
#define IDS_PROMPT_FILTER_BOOT_ADE       0x0000272CL

//
// MessageId: IDS_PROMPT_MENU_CONFIG_ADE
//
// MessageText:
//
//  Add Del Enum: %0
//
#define IDS_PROMPT_MENU_CONFIG_ADE       0x0000272DL

//
// MessageId: IDS_PROMPT_FILTER_CONFIG_ADE
//
// MessageText:
//
//  ADE%0
//
#define IDS_PROMPT_FILTER_CONFIG_ADE     0x0000272EL

//
// MessageId: IDS_PROMPT_MENU_MAIN_ABCPSVWQ
//
// MessageText:
//
//  Adapter Boot Config Profile Service Vendor Wksta [Quit]: %0
//
#define IDS_PROMPT_MENU_MAIN_ABCPSVWQ    0x0000272FL

//
// MessageId: IDS_PROMPT_FILTER_MAIN_ABCPSVWQ
//
// MessageText:
//
//  ABCPSVWQ%0
//
#define IDS_PROMPT_FILTER_MAIN_ABCPSVWQ  0x00002730L

//
// MessageId: IDS_PROMPT_MENU_PROFILE_ACDEGS
//
// MessageText:
//
//  Add Clone Del Enum GetInfo SetInfo: %0
//
#define IDS_PROMPT_MENU_PROFILE_ACDEGS   0x00002731L

//
// MessageId: IDS_PROMPT_FILTER_PROFILE_ACDEGS
//
// MessageText:
//
//  ACDEGS%0
//
#define IDS_PROMPT_FILTER_PROFILE_ACDEGS 0x00002732L

//
// MessageId: IDS_PROMPT_MENU_SERVICE_CGOS
//
// MessageText:
//
//  Close GetInfo Open SetInfo: %0
//
#define IDS_PROMPT_MENU_SERVICE_CGOS     0x00002733L

//
// MessageId: IDS_PROMPT_FILTER_SERVICE_CGOS
//
// MessageText:
//
//  CGOS%0
//
#define IDS_PROMPT_FILTER_SERVICE_CGOS   0x00002734L

//
// MessageId: IDS_PROMPT_MENU_SERVICE_CONFIGS
//
// MessageText:
//
//  Would you like to check for installed configurations [Y,N]=%0
//
#define IDS_PROMPT_MENU_SERVICE_CONFIGS  0x00002735L

//
// MessageId: IDS_PROMPT_MENU_SERVICE_RPLDISK
//
// MessageText:
//
//  Would you like to update client boot files [Y,N]=%0
//
#define IDS_PROMPT_MENU_SERVICE_RPLDISK  0x00002736L

//
// MessageId: IDS_PROMPT_MENU_SERVICE_BACKUP
//
// MessageText:
//
//  Would you backup service database [Y,N]=%0
//
#define IDS_PROMPT_MENU_SERVICE_BACKUP   0x00002737L

//
// MessageId: IDS_PROMPT_FILTER_YN
//
// MessageText:
//
//  YN%0
//
#define IDS_PROMPT_FILTER_YN             0x00002738L

//
// MessageId: IDS_PROMPT_MENU_SERVICE_SECURITY
//
// MessageText:
//
//  Would you check logon domain for remoteboot workstations [Y,N]=%0
//
#define IDS_PROMPT_MENU_SERVICE_SECURITY 0x00002739L

//
// MessageId: IDS_PROMPT_MENU_VENDOR_ADE
//
// MessageText:
//
//  Add Del Enum: %0
//
#define IDS_PROMPT_MENU_VENDOR_ADE       0x0000273AL

//
// MessageId: IDS_PROMPT_FILTER_VENDOR_ADE
//
// MessageText:
//
//  ADE%0
//
#define IDS_PROMPT_FILTER_VENDOR_ADE     0x0000273BL

//
// MessageId: IDS_PROMPT_MENU_WKSTA_ACDEGS
//
// MessageText:
//
//  Add Clone Del Enum GetInfo SetInfo: %0
//
#define IDS_PROMPT_MENU_WKSTA_ACDEGS     0x0000273CL

//
// MessageId: IDS_PROMPT_FILTER_WKSTA_ACDEGS
//
// MessageText:
//
//  ACDEGS%0
//
#define IDS_PROMPT_FILTER_WKSTA_ACDEGS   0x0000273DL

//
// MessageId: IDS_PROMPT_MENU_WKSTA_DELETE
//
// MessageText:
//
//  Delete corresponding user account when workstation is deleted by Remoteboot Manager [Y,N]=%0
//
#define IDS_PROMPT_MENU_WKSTA_DELETE     0x0000273EL

//
// MessageId: IDS_PROMPT_MENU_WKSTA_DHCP
//
// MessageText:
//
//  Does RemoteBoot workstation use DHCP [Y,N]=%0
//
#define IDS_PROMPT_MENU_WKSTA_DHCP       0x0000273FL

//
// MessageId: IDS_PROMPT_MENU_WKSTA_LOGON_INPUT
//
// MessageText:
//
//  Is Remoteboot password Required, Optional or Not solicited [R,O,N]=%0
//
#define IDS_PROMPT_MENU_WKSTA_LOGON_INPUT 0x00002740L

//
// MessageId: IDS_PROMPT_FILTER_WKSTA_LOGON_INPUT
//
// MessageText:
//
//  RON%0
//
#define IDS_PROMPT_FILTER_WKSTA_LOGON_INPUT 0x00002741L

//
// MessageId: IDS_PROMPT_MENU_WKSTA_SHAREDORPRIVATE
//
// MessageText:
//
//  Does RemoteBoot workstation uses shared or private home directory [S,P]=%0
//
#define IDS_PROMPT_MENU_WKSTA_SHAREDORPRIVATE 0x00002742L

//
// MessageId: IDS_PROMPT_FILTER_WKSTA_SHAREDORPRIVATE
//
// MessageText:
//
//  SP%0
//
#define IDS_PROMPT_FILTER_WKSTA_SHAREDORPRIVATE 0x00002743L

//
// MessageId: IDS_PROMPT_PREFMAXLENGTH_DEBUG
//
// MessageText:
//
//  PrefMaxLength (-1 for all data)=%0
//
#define IDS_PROMPT_PREFMAXLENGTH_DEBUG   0x00002744L

//
// MessageId: IDS_PROMPT_PROFILECOMMENT
//
// MessageText:
//
//  ProfileComment=%0
//
#define IDS_PROMPT_PROFILECOMMENT        0x00002745L

//
// MessageId: IDS_PROMPT_PROFILECOMMENT_TARGET
//
// MessageText:
//
//  TargetProfileComment=%0
//
#define IDS_PROMPT_PROFILECOMMENT_TARGET 0x00002746L

//
// MessageId: IDS_PROMPT_PROFILENAME
//
// MessageText:
//
//  ProfileName=%0
//
#define IDS_PROMPT_PROFILENAME           0x00002747L

//
// MessageId: IDS_PROMPT_PROFILENAME_COMPATWKSTA
//
// MessageText:
//
//  To list only workstations using a given profile, input ProfileName=%0
//
#define IDS_PROMPT_PROFILENAME_COMPATWKSTA 0x00002748L

//
// MessageId: IDS_PROMPT_PROFILENAME_INFOLEVEL
//
// MessageText:
//
//  Input Information Level (0, 1 or 2) and ProfileName%n%0
//
#define IDS_PROMPT_PROFILENAME_INFOLEVEL 0x00002749L

//
// MessageId: IDS_PROMPT_PROFILENAME_INPUT
//
// MessageText:
//
//  Input ProfileName=%0
//
#define IDS_PROMPT_PROFILENAME_INPUT     0x0000274AL

//
// MessageId: IDS_PROMPT_PROFILENAME_SOURCE
//
// MessageText:
//
//  SourceProfileName=%0
//
#define IDS_PROMPT_PROFILENAME_SOURCE    0x0000274BL

//
// MessageId: IDS_PROMPT_PROFILENAME_TARGET
//
// MessageText:
//
//  TargetProfileName=%0
//
#define IDS_PROMPT_PROFILENAME_TARGET    0x0000274CL

//
// MessageId: IDS_PROMPT_SERVERNAME
//
// MessageText:
//
//  ServerName=%0
//
#define IDS_PROMPT_SERVERNAME            0x0000274DL

//
// MessageId: IDS_PROMPT_TCPIPADDRESS
//
// MessageText:
//
//  TcpIpAddress (when DHCP is disabled)=%0
//
#define IDS_PROMPT_TCPIPADDRESS          0x0000274EL

//
// MessageId: IDS_PROMPT_TCPIPGATEWAY
//
// MessageText:
//
//  TcpIpGateway (when DHCP is disabled)=%0
//
#define IDS_PROMPT_TCPIPGATEWAY          0x0000274FL

//
// MessageId: IDS_PROMPT_TCPIPSUBNET
//
// MessageText:
//
//  TcpIpSubnet (when DHCP is disabled)=%0
//
#define IDS_PROMPT_TCPIPSUBNET           0x00002750L

//
// MessageId: IDS_PROMPT_VENDORCOMMENT
//
// MessageText:
//
//  VendorComment=%0
//
#define IDS_PROMPT_VENDORCOMMENT         0x00002751L

//
// MessageId: IDS_PROMPT_VENDORNAME
//
// MessageText:
//
//  VendorName=%0
//
#define IDS_PROMPT_VENDORNAME            0x00002752L

//
// MessageId: IDS_PROMPT_BBCFILE
//
// MessageText:
//
//  BbcFile=%0
//
#define IDS_PROMPT_BBCFILE               0x00002753L

//
// MessageId: IDS_PROMPT_WINDOWSIZE
//
// MessageText:
//
//  WindowSize=%0
//
#define IDS_PROMPT_WINDOWSIZE            0x00002754L

//
// MessageId: IDS_PROMPT_WKSTACOMMENT
//
// MessageText:
//
//  WkstaComment=%0
//
#define IDS_PROMPT_WKSTACOMMENT          0x00002755L

//
// MessageId: IDS_PROMPT_WKSTACOMMENT_TARGET
//
// MessageText:
//
//  TargetWkstaComment=%0
//
#define IDS_PROMPT_WKSTACOMMENT_TARGET   0x00002756L

//
// MessageId: IDS_PROMPT_WKSTANAME
//
// MessageText:
//
//  WkstaName=%0
//
#define IDS_PROMPT_WKSTANAME             0x00002757L

//
// MessageId: IDS_PROMPT_WKSTANAME_INFOLEVEL
//
// MessageText:
//
//  Input Information Level (0, 1 or 2) and WkstaName%n%0
//
#define IDS_PROMPT_WKSTANAME_INFOLEVEL   0x00002758L

//
// MessageId: IDS_PROMPT_WKSTANAME_INPUT
//
// MessageText:
//
//  Input WkstaName=%0
//
#define IDS_PROMPT_WKSTANAME_INPUT       0x00002759L

//
// MessageId: IDS_PROMPT_WKSTANAME_SOURCE
//
// MessageText:
//
//  SourceWkstaName=%0
//
#define IDS_PROMPT_WKSTANAME_SOURCE      0x0000275AL

//
// MessageId: IDS_PROMPT_WKSTANAME_TARGET
//
// MessageText:
//
//  TargetWkstaName=%0
//
#define IDS_PROMPT_WKSTANAME_TARGET      0x0000275BL

//
// MessageId: IDS_BADARGCOUNT
//
// MessageText:
//
//  Bad number of arguments.%n%0
//
#define IDS_BADARGCOUNT                  0x0000275CL

//
// MessageId: IDS_BADMENUSEL
//
// MessageText:
//
//  Your input "%1!ws!" is invalid.  One of "%2!ws!" was expected.%n%0
//
#define IDS_BADMENUSEL                   0x0000275DL

//
// MessageId: IDS_INPUTPROFILEPROPERTIES
//
// MessageText:
//
//  Input new profile properties.%n%0
//
#define IDS_INPUTPROFILEPROPERTIES       0x0000275EL

//
// MessageId: IDS_INPUTWKSTAPROPERTIES
//
// MessageText:
//
//  Input new workstation properties.%n%0
//
#define IDS_INPUTWKSTAPROPERTIES         0x0000275FL

//
// MessageId: IDS_INVALIDSTRING_CHARSTRINGA
//
// MessageText:
//
//  Invalid string "%1!s!"%n%0
//
#define IDS_INVALIDSTRING_CHARSTRINGA    0x00002760L

//
// MessageId: IDS_MUSTCLOSEHANDLE
//
// MessageText:
//
//  Must close existing RemoteBoot service handle
//  before opening new RemoteBoot service handle.%n%0
//
#define IDS_MUSTCLOSEHANDLE              0x00002761L

//
// MessageId: IDS_NOSERVICEHANDLE
//
// MessageText:
//
//  You do not have an open RemoteBoot service handle.%n%0
//
#define IDS_NOSERVICEHANDLE              0x00002762L

//
// MessageId: IDS_NOTSUPPLIED
//
// MessageText:
//
//  "%1!ws!" must be supplied%n%0
//
#define IDS_NOTSUPPLIED                  0x00002763L

//
// MessageId: IDS_INVALID_INPUT
//
// MessageText:
//
//  No valid input supplied%n%0
//
#define IDS_INVALID_INPUT                0x00002764L

//
// MessageId: IDS_TARGETSERVER
//
// MessageText:
//
//  ServerName = %1!ws!%n%0
//
#define IDS_TARGETSERVER                 0x00002765L

//
// MessageId: IDS_USAGE
//
// MessageText:
//
//  The RPLCMD utility can be used to view and update the Remoteboot service
//  database.  The Remoteboot service must already be running.%n
//  %n
//  RPLCMD [\\computername]%n
//  %n
//  \\computername     Specifies a remote computer where the Remoteboot service%n
//                     is running.  If this parameter is omitted, RPLCMD manages%n
//                     the Remoteboot service on the local computer.%n
//
#define IDS_USAGE                        0x00002766L

//
// MessageId: IDS_PARAMETERSOPTIONAL
//
// MessageText:
//
//  %tAll other parameters are optional%n%0
//
#define IDS_PARAMETERSOPTIONAL           0x00002767L

//
// MessageId: IDS_ADAPTERBADFLAGS
//
// MessageText:
//
//  %tBad Adapter flags, Flags=0x%1!x!%n%0
//
#define IDS_ADAPTERBADFLAGS              0x00002768L

//
// MessageId: IDS_ADAPTERCOMMENT
//
// MessageText:
//
//  %tAdapterComment=%1!ws!%n%0
//
#define IDS_ADAPTERCOMMENT               0x00002769L

//
// MessageId: IDS_BBCFILE
//
// MessageText:
//
//  %tBbcFile=%1!ws!%n%0
//
#define IDS_BBCFILE                      0x0000276AL

//
// MessageId: IDS_BOOTACK_FALSE
//
// MessageText:
//
//  %tAcknowledgment of the last RemoteBoot frame is not requested.%n%0
//
#define IDS_BOOTACK_FALSE                0x0000276BL

//
// MessageId: IDS_BOOTACK_TRUE
//
// MessageText:
//
//  %tAcknowledgment of the last RemoteBoot frame is requested.%n%0
//
#define IDS_BOOTACK_TRUE                 0x0000276CL

//
// MessageId: IDS_BOOTBADFLAGS
//
// MessageText:
//
//  %tBad Boot flags, Flags=0x%1!x!%n%0
//
#define IDS_BOOTBADFLAGS                 0x0000276DL

//
// MessageId: IDS_BOOTCOMMENT
//
// MessageText:
//
//  %tBootComment=%1!ws!%n%0
//
#define IDS_BOOTCOMMENT                  0x0000276EL

//
// MessageId: IDS_BOOTNAME
//
// MessageText:
//
//  %tBootName=%1!ws!%n%0
//
#define IDS_BOOTNAME                     0x0000276FL

//
// MessageId: IDS_CONFIGBADFLAGS
//
// MessageText:
//
//  %tBad Configuration flags, Flags=0x%1!x!%n%0
//
#define IDS_CONFIGBADFLAGS               0x00002770L

//
// MessageId: IDS_CONFIGCOMMENT
//
// MessageText:
//
//  %tConfigComment=%1!ws!%n%0
//
#define IDS_CONFIGCOMMENT                0x00002771L

//
// MessageId: IDS_CONFIGDISABLED
//
// MessageText:
//
//  %tConfiguration is disabled.%n%0
//
#define IDS_CONFIGDISABLED               0x00002772L

//
// MessageId: IDS_CONFIGENABLED
//
// MessageText:
//
//  %tConfiguration is enabled.%n%0
//
#define IDS_CONFIGENABLED                0x00002773L

//
// MessageId: IDS_CONFIGNAME
//
// MessageText:
//
//  %tConfigName=%1!ws!%n%0
//
#define IDS_CONFIGNAME                   0x00002774L

//
// MessageId: IDS_DIRNAME
//
// MessageText:
//
//  %tDirName=%1!ws!%n%0
//
#define IDS_DIRNAME                      0x00002775L

//
// MessageId: IDS_DIRNAME2
//
// MessageText:
//
//  %tDirName2=%1!ws!%n%0
//
#define IDS_DIRNAME2                     0x00002776L

//
// MessageId: IDS_DIRNAME3
//
// MessageText:
//
//  %tDirName3=%1!ws!%n%0
//
#define IDS_DIRNAME3                     0x00002777L

//
// MessageId: IDS_DIRNAME4
//
// MessageText:
//
//  %tDirName4=%1!ws!%n%0
//
#define IDS_DIRNAME4                     0x00002778L

//
// MessageId: IDS_FITFILE
//
// MessageText:
//
//  %tFitFile=%1!ws!%n%0
//
#define IDS_FITFILE                      0x00002779L

//
// MessageId: IDS_FITPERSONAL
//
// MessageText:
//
//  %tFitPersonal=%1!ws!%n%0
//
#define IDS_FITPERSONAL                  0x0000277AL

//
// MessageId: IDS_FITSHARED
//
// MessageText:
//
//  %tFitShared=%1!ws!%n%0
//
#define IDS_FITSHARED                    0x0000277BL

//
// MessageId: IDS_PROFILEBADFLAGS
//
// MessageText:
//
//  %tBad Profile flags, Flags = 0x%1!x!%n%0
//
#define IDS_PROFILEBADFLAGS              0x0000277CL

//
// MessageId: IDS_PROFILECOMMENT
//
// MessageText:
//
//  %tProfileComment=%1!ws!%n%0
//
#define IDS_PROFILECOMMENT               0x0000277DL

//
// MessageId: IDS_PROFILENODISKTREE
//
// MessageText:
//
//  %tDisk tree for this profile may be absent.%n%0
//
#define IDS_PROFILENODISKTREE            0x0000277EL

//
// MessageId: IDS_TCPIPADDRESS
//
// MessageText:
//
//  %tTcpIpAddress=0x%1!x!%n%0
//
#define IDS_TCPIPADDRESS                 0x0000277FL

//
// MessageId: IDS_TCPIPGATEWAY
//
// MessageText:
//
//  %tTcpIpGateway=0x%1!x!%n%0
//
#define IDS_TCPIPGATEWAY                 0x00002780L

//
// MessageId: IDS_TCPIPSUBNET
//
// MessageText:
//
//  %tTcpIpSubnet=0x%1!x!%n%0
//
#define IDS_TCPIPSUBNET                  0x00002781L

//
// MessageId: IDS_SERVICEBADFLAGS
//
// MessageText:
//
//  %tBad Service flags, Flags=0x%1!x!%n%0
//
#define IDS_SERVICEBADFLAGS              0x00002782L

//
// MessageId: IDS_VENDORBADFLAGS
//
// MessageText:
//
//  %tBad Vendor flags, Flags = 0x%1!x!%n%0
//
#define IDS_VENDORBADFLAGS               0x00002783L

//
// MessageId: IDS_VENDORCOMMENT
//
// MessageText:
//
//  %tVendorComment=%1!ws!%n%0
//
#define IDS_VENDORCOMMENT                0x00002784L

//
// MessageId: IDS_VENDORNAME
//
// MessageText:
//
//  %tVendorName=%1!ws!%n%0
//
#define IDS_VENDORNAME                   0x00002785L

//
// MessageId: IDS_WINDOWSIZE
//
// MessageText:
//
//  %tWindowSize=0x%1!x!%n%0
//
#define IDS_WINDOWSIZE                   0x00002786L

//
// MessageId: IDS_WKSTAADAPTER
//
// MessageText:
//
//  %tAdapterName=%1!ws!%n%0
//
#define IDS_WKSTAADAPTER                 0x00002787L

//
// MessageId: IDS_WKSTACOMMENT
//
// MessageText:
//
//  %tWkstaComment=%1!ws!%n%0
//
#define IDS_WKSTACOMMENT                 0x00002788L

//
// MessageId: IDS_WKSTAINPROFILE
//
// MessageText:
//
//  %tProfileName=%1!ws!%n%0
//
#define IDS_WKSTAINPROFILE               0x00002789L

//
// MessageId: IDS_WKSTALOGONBADFLAGS
//
// MessageText:
//
//  %tBad Remoteboot password flags, Flags = 0x%1!x!%n%0
//
#define IDS_WKSTALOGONBADFLAGS           0x0000278AL

//
// MessageId: IDS_WKSTALOGONNONE
//
// MessageText:
//
//  %tRemoteBoot password is not solicited%n%0
//
#define IDS_WKSTALOGONNONE               0x0000278BL

//
// MessageId: IDS_WKSTALOGONOPT
//
// MessageText:
//
//  %tRemoteBoot password is optional%n%0
//
#define IDS_WKSTALOGONOPT                0x0000278CL

//
// MessageId: IDS_WKSTALOGONREQD
//
// MessageText:
//
//  %tRemoteBoot password is requred%n%0
//
#define IDS_WKSTALOGONREQD               0x0000278DL

//
// MessageId: IDS_WKSTASHARINGBADFLAGS
//
// MessageText:
//
//  %tBad Remoteboot home directory flags, Flags = 0x%1!x!%n%0
//
#define IDS_WKSTASHARINGBADFLAGS         0x0000278EL

//
// MessageId: IDS_WKSTASHARINGFALSE
//
// MessageText:
//
//  %tUses private home directory%n%0
//
#define IDS_WKSTASHARINGFALSE            0x0000278FL

//
// MessageId: IDS_WKSTASHARINGTRUE
//
// MessageText:
//
//  %tUses shared home directory%n%0
//
#define IDS_WKSTASHARINGTRUE             0x00002790L

//
// MessageId: IDS_WKSTA_DELETE_TRUE
//
// MessageText:
//
//  %tUser will be deleted when workstation is deleted by Remoteboot Manager%n%0
//
#define IDS_WKSTA_DELETE_TRUE            0x00002791L

//
// MessageId: IDS_WKSTA_DELETE_FALSE
//
// MessageText:
//
//  %tUser will be not deleted when workstation is deleted by Remoteboot Manager%n%0
//
#define IDS_WKSTA_DELETE_FALSE           0x00002792L

//
// MessageId: IDS_WKSTA_DELETE_BAD_FLAGS
//
// MessageText:
//
//  %tBad DELETE flags, Flags = 0x%1!x!%n%0
//
#define IDS_WKSTA_DELETE_BAD_FLAGS       0x00002793L

//
// MessageId: IDS_WKSTA_DHCP_TRUE
//
// MessageText:
//
//  %tUses DHCP (when TCP/IP is enabled)%n%0
//
#define IDS_WKSTA_DHCP_TRUE              0x00002794L

//
// MessageId: IDS_WKSTA_DHCP_FALSE
//
// MessageText:
//
//  %tDoes not use DHCP (when TCP/IP is enabled)%n%0
//
#define IDS_WKSTA_DHCP_FALSE             0x00002795L

//
// MessageId: IDS_WKSTA_DHCP_BAD_FLAGS
//
// MessageText:
//
//  %tBad DHCP flags, Flags = 0x%1!x!%n%0
//
#define IDS_WKSTA_DHCP_BAD_FLAGS         0x00002796L

//
// MessageId: IDS_PROFILENAME_NOTAB
//
// MessageText:
//
//  ProfileName=%1!ws!%n%0
//
#define IDS_PROFILENAME_NOTAB            0x00002797L

//
// MessageId: IDS_ADAPTERNAME_NOTAB
//
// MessageText:
//
//  AdapterName=%1!ws!%n%0
//
#define IDS_ADAPTERNAME_NOTAB            0x00002798L

//
// MessageId: IDS_BOOTNAME_NOTAB
//
// MessageText:
//
//  BootName=%1!ws!%n%0
//
#define IDS_BOOTNAME_NOTAB               0x00002799L

//
// MessageId: IDS_CONFIGNAME_NOTAB
//
// MessageText:
//
//  ConfigName=%1!ws!%n%0
//
#define IDS_CONFIGNAME_NOTAB             0x0000279AL

//
// MessageId: IDS_VENDORNAME_NOTAB
//
// MessageText:
//
//  VendorName=%1!ws!%n%0
//
#define IDS_VENDORNAME_NOTAB             0x0000279BL

//
// MessageId: IDS_WKSTANAME_NOTAB
//
// MessageText:
//
//  WkstaName=%1!ws!%n%0
//
#define IDS_WKSTANAME_NOTAB              0x0000279CL

//
// MessageId: IDS_RPLSVC_COMPUTER
//
// MessageText:
//
//  Managing remoteboot service at computer %1!ws!.%n%0
//
#define IDS_RPLSVC_COMPUTER              0x0000279DL

//
// MessageId: IDS_RPLSVC_LOCAL_COMPUTER
//
// MessageText:
//
//  Managing remoteboot service at local computer.%n%0
//
#define IDS_RPLSVC_LOCAL_COMPUTER        0x0000279EL

