/*++

Copyright (c) 1992  Microsoft Corporation

Module Name:

    rplimsg.h

Abstract:

    Definitions for RPLCNV command private errors.

Author:

    Jon Newman              (jonn)          21 - April - 1994

Revision History:

    21-Apr-1994     jonn
        templated from AT command

Notes:

    This file is generated by the MC tool from the lmatmsg.mc file.

--*/
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: RPLI_CVT_NoMDB
//
// MessageText:
//
//  File system.mdb is absent.%n
//
#define RPLI_CVT_NoMDB                   0x00002AF8L

//
// MessageId: RPLI_CVT_StopService
//
// MessageText:
//
//  Remote boot service must be stopped for this program to run.%n
//
#define RPLI_CVT_StopService             0x00002AF9L

//
// MessageId: RPLI_CVT_InitError
//
// MessageText:
//
//  Unexpected initialization error.%n
//
#define RPLI_CVT_InitError               0x00002AFAL

//
// MessageId: RPLI_CVT_CannotOpenFile
//
// MessageText:
//
//  Cannot open %1!ws!%n
//
#define RPLI_CVT_CannotOpenFile          0x00002AFBL

//
// MessageId: RPLI_CVT_ProfileInvalid
//
// MessageText:
//
//  Not converting %1!ws! profile because its name is invalid.%n
//
#define RPLI_CVT_ProfileInvalid          0x00002AFCL

//
// MessageId: RPLI_CVT_ProfileInvalidConfig
//
// MessageText:
//
//  Not converting %1!ws! profile because its configuration %2!ws!
//  is invalid.%n
//
#define RPLI_CVT_ProfileInvalidConfig    0x00002AFDL

//
// MessageId: RPLI_CVT_ProfileInvalidFit
//
// MessageText:
//
//  Not converting %1!ws! profile because its fit file %2!ws!
//  is invalid.%n
//
#define RPLI_CVT_ProfileInvalidFit       0x00002AFEL

//
// MessageId: RPLI_CVT_ProfileInvalidBoot
//
// MessageText:
//
//  Not converting %1!ws! profile because its boot block name %2!ws!
//  is invalid.%n
//
#define RPLI_CVT_ProfileInvalidBoot      0x00002AFFL

//
// MessageId: RPLI_CVT_USAGE
//
// MessageText:
//
//  The RPLCNV utility (RemoteBoot conversion program) converts
//  rpl.map and rplmgr.ini used by OS/2 LANMAN Remoteboot service into system.mdb
//  and rplsvc.mdb files used by NT Remoteboot service.  Install the Remoteboot
//  service before running the Remoteboot conversion program, and
//  make sure a copy of the original system.mdb file is in
//  the root of the RPL file tree as specified during RPL installation.%n
//  %n
//  RPLCNV [Path]%n
//  %n
//  Path    Specifies a fully qualified path to the directory containing the
//  rpl.map and rplmgr.ini files used by OS/2 LANMAN RemoteBoot service.
//  If this parameter is omitted it is assumed that these files are in the
//  current directory or the root of the RPL file tree.
//
#define RPLI_CVT_USAGE                   0x00002B00L

//
// MessageId: RPLI_CVT_NoMAP_INI
//
// MessageText:
//
//  Files rpl.map and/or rplmgr.ini are absent.%n
//
#define RPLI_CVT_NoMAP_INI               0x00002B01L

//
// MessageId: RPLI_CVT_NoSystemMdb
//
// MessageText:
//
//  File system.mdb is absent from the root of the RPL file tree.
//  RPLCNV cannot convert rpl.map and rplmgr.ini unless a copy
//  of the original system.mdb file is in the root of the RPL file tree.%n
//
#define RPLI_CVT_NoSystemMdb             0x00002B02L

//
// MessageId: RPLI_CVT_RplsvcMdbExists
//
// MessageText:
//
//  File rplsvc.mdb already exists in the root of the RPL file tree.
//  RPLCNV will not create a new one until the existing one is moved,
//  renamed or deleted.%n
//
#define RPLI_CVT_RplsvcMdbExists         0x00002B03L

//
// MessageId: RPLI_CVT_OldSystemMdb
//
// MessageText:
//
//  File system.mdb exists in the root of the RPL file tree but is not
//  a copy of the original system.mdb file.  RPLCNV cannot convert rpl.map
//  and rplmgr.ini unless a copy of the original system.mdb file is in the
//  root of the RPL file tree.%n
//
#define RPLI_CVT_OldSystemMdb            0x00002B04L

//
// MessageId: RPLI_CVT_BootNameTooLong
//
// MessageText:
//
//  Boot block record with name %1!ws! is not converted because
//  its name is too long or invalid.%n
//
#define RPLI_CVT_BootNameTooLong         0x00002B05L

//
// MessageId: RPLI_CVT_BbcFileTooLong
//
// MessageText:
//
//  Boot block record with name %1!ws! is not converted because
//  path to boot block configuration file %2!ws! is too long or
//  invalid.%n
//
#define RPLI_CVT_BbcFileTooLong          0x00002B06L

//
// MessageId: RPLI_CVT_BadVendorName
//
// MessageText:
//
//  Boot block record with name %1!ws! is not converted because
//  vendor name %2!ws! is invalid.%n
//
#define RPLI_CVT_BadVendorName           0x00002B07L

//
// MessageId: RPLI_CVT_WkstaInvalid
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted because
//  its name is too long or invalid.%n
//
#define RPLI_CVT_WkstaInvalid            0x00002B08L

//
// MessageId: RPLI_CVT_WkstaInvalidAdapter
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted because
//  adapter id %2!ws! is invalid.%n
//
#define RPLI_CVT_WkstaInvalidAdapter     0x00002B09L

//
// MessageId: RPLI_CVT_WkstaInvalidLogon
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted because
//  remoteboot username/password prompting field %2!ws! is invalid.%n
//
#define RPLI_CVT_WkstaInvalidLogon       0x00002B0AL

//
// MessageId: RPLI_CVT_WkstaInvalidFit
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted because
//  fit name %2!ws! is too long or invalid.%n
//
#define RPLI_CVT_WkstaInvalidFit         0x00002B0BL

//
// MessageId: RPLI_CVT_WkstaInvalidSharing
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted because
//  sharing type %2!ws! is invalid.%n
//
#define RPLI_CVT_WkstaInvalidSharing     0x00002B0CL

//
// MessageId: RPLI_CVT_WkstaDisabledBoot
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted since its
//  reference to block record %2!ws! is disabled.%n
//
#define RPLI_CVT_WkstaDisabledBoot       0x00002B0DL

//
// MessageId: RPLI_CVT_WkstaInvalidBoot
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted because
//  boot block name %2!ws! is invalid.%n
//
#define RPLI_CVT_WkstaInvalidBoot        0x00002B0EL

//
// MessageId: RPLI_CVT_WkstaInvalidProfile
//
// MessageText:
//
//  Workstation record with name %1!ws! is not converted because
//  profile name %2!ws! is invalid.%n
//
#define RPLI_CVT_WkstaInvalidProfile     0x00002B0FL

//
// MessageId: RPLI_CVT_WkstaDuplicateName
//
// MessageText:
//
//  Workstation record is not converted because it uses a duplicate computer name
//  (%1!ws!) or a duplicate adapter id (%2!ws!).%n
//
#define RPLI_CVT_WkstaDuplicateName      0x00002B10L

//
// MessageId: RPLI_CVT_WkstaDefaultProfile
//
// MessageText:
//
//  Workstation record with computer name %1!ws! is not converted
//  because it uses the obsolete DEFAULT profile.%n
//
#define RPLI_CVT_WkstaDefaultProfile     0x00002B11L

//
// MessageId: RPLI_CVT_ConfigNoPersonalFIT
//
// MessageText:
//
//  Not converting %1!ws! configuration because it does not have
//  a fit file for personal profiles.%n
//
#define RPLI_CVT_ConfigNoPersonalFIT     0x00002B12L

//
// MessageId: RPLI_CVT_ConfigNoOS2
//
// MessageText:
//
//  Not converting %1!ws! configuration because it is an OS/2
//  client configuration.%n
//
#define RPLI_CVT_ConfigNoOS2             0x00002B13L

//
// MessageId: RPLI_CVT_ConfigInvalid
//
// MessageText:
//
//  Not converting %1!ws! configuration because the value of
//  keyword %2!ws! is absent or invalid.%n
//
#define RPLI_CVT_ConfigInvalid           0x00002B14L

